import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Container;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.GridLayout;
import java.awt.Image;
import java.awt.Menu;
import java.awt.MenuBar;
import java.awt.MenuItem;
import java.awt.MenuShortcut;
import java.awt.Rectangle;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ComponentAdapter;
import java.awt.event.ComponentEvent;
import java.awt.event.FocusAdapter;
import java.awt.event.FocusEvent;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.File;
import java.util.GregorianCalendar;
import java.util.StringTokenizer;

import javax.imageio.ImageIO;
import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JComponent;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextPane;
import javax.swing.JToolBar;
import javax.swing.text.Document;
import javax.swing.text.SimpleAttributeSet;
import javax.swing.text.StyleConstants;

import kemachat.ChatUser;
import kemachat.MainUser;
import kwt.KFileManager;
import kwt.Sound;
import kwt.User;

/**
 * 
 * 
 * @author Matteo Pagamici Copyright (c) 2006 Matteo Pagamici All rights
 *         reserved
 * 
 */

public class ChatWindow extends JFrame {
	private static final long serialVersionUID = 1L;

	public boolean init = false;

	public boolean killed = false;

	public boolean mustscroll = true;

	public int lastscroll = 0;

	public JLabel myavatar = new JLabel("", JLabel.CENTER);

	public JLabel hisavatar = new JLabel("", JLabel.CENTER);

	public JLabel myavatar_l = new JLabel("", JLabel.CENTER);

	public JLabel hisavatar_l = new JLabel("", JLabel.CENTER);

	public JPanel p_myavatar = new JPanel();

	public JPanel p_hisavatar = new JPanel();

	public int pane_size_x = 1000;

	public int pane_size_y = 1000;

	public int pane_pos_x = 0;

	public int pane_pos_y = 0;

	public Image base = Toolkit.getDefaultToolkit().getImage(
			User.getHome() + "/KemaChat/" + MainUser.background_constant);

	public Image bild = base.getScaledInstance(pane_size_x, pane_size_y,
			Image.SCALE_DEFAULT);

	public String history = "";

	/*
	 * 
	 * public KTextPane pane = new KTextPane() { private static final long
	 * serialVersionUID = 1L;
	 * 
	 * public void paintComponent(Graphics g) {
	 * 
	 * g.drawImage(bild, pane_pos_x, pane_pos_y, this);
	 * 
	 * super.paintComponent(g); } };
	 */
	public Pane pane_panel = new Pane();

	public JTextPane pane = pane_panel.pane;

	// public JTextPane pane = new JTextPane();

	public JTextArea field = new JTextArea(4, 10);

	public JToolBar tools = new JToolBar();

	public JPanel writePanel = new JPanel();

	public Document document = pane.getStyledDocument();

	public SimpleAttributeSet set = new SimpleAttributeSet();

	public SimpleAttributeSet smilies = new SimpleAttributeSet();

	public static int chatwindow_space = 0;

	public Container c;

	public JScrollPane scroller = new JScrollPane(pane);

	public ChatUser user;

	public JScrollPane message_scroller = new JScrollPane(field);

	public Thread t_scroll;

	public Thread t_reader;

	public Thread t_focus;

	public Thread t_avatar;

	public Thread t_background;

	public MenuBar menubar = new MenuBar();

	public Menu fenster = new Menu("Fenster");

	public Menu kontakt = new Menu("Kontakt");

	public MenuItem closefenster = new MenuItem("Fenster schliessen");

	public MenuItem viewHistory = new MenuItem("History anschauen");

	public MenuItem deleteUser = new MenuItem("User l\u00f6schen");

	public ChatWindow(ChatUser myUser) {
		super();
		user = myUser;
	}

	public JPanel avatar_panel = new JPanel();

	public boolean running_title = false;

	public void init() {

		KemaChat.p("start init");

		history += "<FONT style=\"font-family: Arial; color: rgb(0, 0, 0)\"><B>Gespr&auml;ch um "
				+ getCurrentTime() + " Uhr gestartet.</B></FONT><BR><BR>\n";

		class FocusSeeker implements Runnable {
			public void run() {
				while (true && !killed) {
					try {
						String thisuser = user.getName();
						if (!KemaChat.focusto.equals("")
								&& KemaChat.focusto.equals(thisuser)) {
							KemaChat.focusto = "";
							setVisible(true);
						}
						Thread.sleep(500);
					} catch (Exception E) {
						E.printStackTrace();
					}
				}
			}
		}

		class BackgroundManager implements Runnable {
			public void run() {/*
								 * while (true && !killed) { try {
								 * if(KemaChat.mustRepaintBackground) {
								 * Thread.sleep(10000); pane_panel.img =
								 * Toolkit.getDefaultToolkit().getImage(User.getHome()+"/KemaChat/background.png").getScaledInstance(MainUser.chatframe_dimension.width-61,
								 * MainUser.chatframe_dimension.height-99,
								 * Image.SCALE_DEFAULT); pane_panel.repaint();
								 * KemaChat.mustRepaintBackground = false; }
								 * Thread.sleep(10000); } catch (Exception E) {
								 * E.printStackTrace(); } }
								 */
			}
		}

		class TitleManager implements Runnable {
			public void run() {
				running_title = true;
				while (!isFocused() && !killed) {
					try {
						String old_title = getTitle();
						setTitle("Neue Nachricht");
						Thread.sleep(500);
						setTitle(old_title);
						Thread.sleep(500);
					} catch (Exception E) {
						running_title = false;
						setTitle("Chat mit "
								+ KemaChat.formatText(user.getNickName(), user)
								+ " (" + user.getName() + ")");
						break;
					}
				}
				running_title = false;
				setTitle("Chat mit "
						+ KemaChat.formatText(user.getNickName(), user) + " ("
						+ user.getName() + ")");
			}
		}

		class MessageReader implements Runnable {
			public void run() {
				while (true && !killed) {
					try {
						int style = 0;
						if (MainUser.write_bold == 1) {
							style += Font.BOLD;
						}
						if (MainUser.write_italic == 1) {
							style += Font.ITALIC;
						}
						field.setFont(new Font(MainUser.write_font, style, 14));
						Color thecolor = new Color(MainUser.write_color1,
								MainUser.write_color2, MainUser.write_color3);
						field.setForeground(thecolor);
						int i = 0;
						for (i = 0; i < 10; i++) {
							File pathfile = new File(User.getHome()
									+ "/Public/Drop Box/message_"
									+ user.getName() + "_" + i);
							if (pathfile.exists()) {
								String read = KFileManager.readFile(pathfile
										.toString());
								insertFormattedText(read);
								pathfile.delete();
								Thread.sleep(100);
								pane.scrollRectToVisible(new Rectangle(100000,
										100000, 100000, 100000));
								if (!isFocused() && !running_title) {
									TitleManager title_manager = new TitleManager();
									Thread t_title = new Thread(title_manager);
									t_title.start();
								}
								if (MainUser.sound_play_newmessage) {
									if (MainUser.sound_always_newmessage) {
										Sound to_play = new Sound("sounds/"
												+ MainUser.sound_newmessage
												+ ".aif");
										to_play.play();
									} else {
										if (!isFocused()) {
											Sound to_play = new Sound("sounds/"
													+ MainUser.sound_newmessage
													+ ".aif");
											to_play.play();
										}
									}
								}
							}
						}
						Thread.sleep(100);
					} catch (InterruptedException ie) {
						break;
					} catch (Exception E) {
						continue;
					}
				}
			}
		}
		class ScrollManager implements Runnable {
			public void run() {
				while (true && !killed) {
					try {
						if (field.isFocusOwner()) {
							pane.scrollRectToVisible(new Rectangle(100000,
									100000, 100000, 100000));
						}
						Thread.sleep(100);
					} catch (Exception E) {
						break;
					}
				}
			}
		}

		scroller.getVerticalScrollBar().addMouseListener(new MouseAdapter() {
			public void mousePressed(MouseEvent me) {
				pane.requestFocus();
			}

			public void mouseReleased(MouseEvent me) {

				pane.repaint();
			}
		});
		scroller.getViewport().addMouseListener(new MouseAdapter() {
			public void mousePressed(MouseEvent me) {

				pane.requestFocus();
			}

			public void mouseReleased(MouseEvent me) {

				pane.repaint();
			}
		});

		closefenster.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ae) {
				deleteWindow();
				setVisible(false);
			}
		});

		deleteUser.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ae) {
				KemaChat.deleteUser(user.getName());
				setVisible(true);
			}
		});

		viewHistory.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ae) {
				HistoryViewer.showHistory(user.getName());
			}
		});

		p_myavatar.setLayout(new BorderLayout());
		p_hisavatar.setLayout(new BorderLayout());
		closefenster.setShortcut(new MenuShortcut((int) 'W', false));
		viewHistory.setShortcut(new MenuShortcut((int) 'H', true));
		fenster.add(closefenster);
		kontakt.add(deleteUser);
		kontakt.addSeparator();
		kontakt.add(viewHistory);
		menubar.add(kontakt);
		menubar.add(fenster);
		setMenuBar(menubar);
		String title = "Chat mit "
				+ KemaChat.formatText(user.getNickName(), user) + " ("
				+ KemaChat.formatText(user.getName(), user) + ")";
		setTitle(title);
		if (!user.isOnline()) {
			Message error_message = new Message();
			error_message.bold = 1;
			error_message.color = Color.ORANGE;
			error_message.font_family = "Arial";
			error_message.text = "Warnung: Es k\u00f6nnen keine Nachrichten gesendet werden,%_Nda "
					+ user.getName() + " nicht online ist.%_N%_N";
			insertFormattedText(error_message.getMessage());
		}

		ScrollManager scroll_manager = new ScrollManager();
		t_scroll = new Thread(scroll_manager);
		t_scroll.start();

		BackgroundManager bg_manager = new BackgroundManager();
		t_background = new Thread(bg_manager);
		t_background.start();
		c = getContentPane();
		setSize(MainUser.chatframe_dimension);
		/*
		 * setLocation( (int) MainUser.chatframe_location.getX() +
		 * chatwindow_space, (int) MainUser.chatframe_location.getY() +
		 * chatwindow_space);
		 */
		setLocation((int) MainUser.chatframe_location.getX(),
				(int) MainUser.chatframe_location.getY());
		// pane.setEditable(false);

		addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent we) {
				setVisible(false);
				deleteWindow();
				KemaChat.createUserData();
			}
		});

		avatar_panel.setLayout(new BorderLayout());

		class AvatarManager implements Runnable {
			public void run() {
				while (true && !killed) {
					try {
						File avatar_file = new File(user.path
								+ "/KemaChat/avatar.jpg");

						if (avatar_file.exists()) {
							String avatar_image = avatar_file.getAbsolutePath();
							int scaler = MainUser.avatar_size + 1;
							try {
								Icon avatar_icon = new ImageIcon(ImageIO.read(
										new File(avatar_image))
										.getScaledInstance(scaler, scaler,
												Image.SCALE_DEFAULT));
								hisavatar.setIcon(avatar_icon);
								hisavatar.setText("");
							} catch (Exception E) {
								E.printStackTrace();
							}
							hisavatar_l.setText("<html><b>" + user.getName()
									+ "</b></html>");
							hisavatar.setText("");
							hisavatar.setVisible(true);
						} else {
							hisavatar.setIcon(null);
							hisavatar.setVisible(false);
							hisavatar_l.setText("<html><b>" + user.getName()
									+ "</b></html>");
							hisavatar.setText("");
						}
						if (MainUser.avatar_size == 0) {
							myavatar.setVisible(false);
							hisavatar.setVisible(false);
						} else {
							myavatar.setVisible(true);
							hisavatar.setVisible(true);
						}
						// myavatar.setText("<html><center><img
						// src=\"file://"+User.getHome()+"/kemachat/avatar/\"
						// height="+MainUser.avatar_size+"
						// width="+MainUser.avatar_size+"><br>"+MainUser.name+"</center></html>");

						avatar_file = new File(User.getHome()
								+ "/KemaChat/avatar.jpg");
						String avatar_image = avatar_file.getAbsolutePath();
						int scaler = MainUser.avatar_size + 1;
						try {
							Icon avatar_icon = new ImageIcon(ImageIO.read(
									new File(avatar_image)).getScaledInstance(
									scaler, scaler, Image.SCALE_DEFAULT));
							myavatar.setIcon(avatar_icon);
							myavatar.setText("");
							myavatar_l.setText("<html><b>" + User.getName()
									+ "</b></html>");
						} catch (Exception E) {
							E.printStackTrace();
						}
						Thread.sleep(1000);
					} catch (Exception E) {
						E.printStackTrace();
					}
				}
			}
		}

		AvatarManager avatar_manager = new AvatarManager();
		t_avatar = new Thread(avatar_manager);
		t_avatar.start();

		FocusSeeker focusseeker = new FocusSeeker();
		t_focus = new Thread(focusseeker);
		t_focus.start();

		p_myavatar.add(myavatar);
		p_myavatar.add(myavatar_l, BorderLayout.SOUTH);

		p_hisavatar.add(hisavatar);
		p_hisavatar.add(hisavatar_l, BorderLayout.SOUTH);

		avatar_panel.add(p_hisavatar, BorderLayout.NORTH);
		avatar_panel.add(p_myavatar, BorderLayout.SOUTH);

		c.add(avatar_panel, BorderLayout.EAST);

		field.addKeyListener(new KeyAdapter() {
			public void keyPressed(KeyEvent ke) {
				pane.scrollRectToVisible(new Rectangle(100000, 100000, 100000,
						100000));
				KemaChat.p("consumed: " + ke.isConsumed());
				if (ke.getKeyChar() == '\n') {
					String startMessage = field.getText();

					if (startMessage.replaceAll("\n", "").equals("")) {
						field.setText("");
						return;
					}
					startMessage = startMessage.replaceAll("\n", "%_N");
					Color ad_color = new Color(123, 123, 123);
					if (MainUser.ad_color == 0)
						ad_color = Color.BLACK;
					else if (MainUser.ad_color == 1)
						ad_color = Color.DARK_GRAY;
					else if (MainUser.ad_color == 2)
						ad_color = Color.GRAY;
					else if (MainUser.ad_color == 3)
						ad_color = Color.LIGHT_GRAY;
					else if (MainUser.ad_color == 4)
						ad_color = Color.WHITE;
					String message = "" + ad_color.getRed() + " "
							+ ad_color.getGreen() + " " + ad_color.getBlue()
							+ "\n" + "Arial\n" + "\n" + "" + 0 + "\n" + "" + 1
							+ "\n" + "" + 0 + "\n" + "" + MainUser.nickname
							+ " [" + MainUser.name + "] sagt um "
							+ getCurrentTime() + " Uhr:%_N\n" + ""
							+ MainUser.write_color1 + " "
							+ MainUser.write_color2 + " "
							+ MainUser.write_color3 + "\n" + ""
							+ MainUser.write_font + "\n" + ""
							+ MainUser.write_bold + "\n" + ""
							+ MainUser.write_italic + "\n" + ""
							+ MainUser.write_underline + "\n" + ""
							+ startMessage + "%_N%_N";
					if (startMessage.indexOf("!_usedesign") != -1
							&& !user.getDesign().replaceAll("\n", "").endsWith(
									".kthm")) {
						String next_name = user.getNickName().replaceAll("\n",
								"");
						String next_design = user.getDesign().replaceAll("\n",
								"");
						KemaChat.design = user.getDesign();
						KemaChat.updateDesign();
						message = "" + 123 + " " + 123 + " " + 123 + "\n"
								+ "Arial\n" + "\n" + "" + 0 + "\n" + "" + 1
								+ "\n" + "" + 0 + "\n" + "" + MainUser.nickname
								+ " [" + MainUser.name + "] - "
								+ getCurrentTime() + " Uhr:%_N\n" + "" + 0
								+ " " + 0 + " " + 0 + "\n" + "" + "Arial"
								+ "\n" + "" + 1 + "\n" + "" + 1 + "\n" + "" + 1
								+ "\n" + "" + "" + MainUser.nickname
								+ " verwendet jetzt das Design (" + next_design
								+ "), das " + next_name
								+ " ausgew\u00e4hlt hat." + "%_N%_N";
						KemaChat.design = user.getDesign();
						KemaChat.updateDesign();
						KFileManager.writeFile(User.getHome()
								+ "/KemaChat/design", user.getDesign());
					} else if (startMessage.indexOf("!_usedesign") != -1
							&& user.getDesign().replaceAll("\n", "").endsWith(
									".kthm")) {
						Toolkit.getDefaultToolkit().beep();
						int must_copy = JOptionPane
								.showConfirmDialog(
										null,
										"<html><b>"
												+ user.getName()
												+ " hat kein Standarddesign ausgew&auml;hlt. Wollen Sie sein Design kopieren?<br>(Falls Sie momentan kein Standarddesign verwenden, wird ihr aktuelles Design &uuml;berschrieben)</b></html>",
										"", JOptionPane.YES_NO_OPTION);
						if (must_copy == 0) {
							String design = user.getDesign();
							KemaChat.design = design;
							Runtime run = Runtime.getRuntime();
							try {
								run.exec("cp " + user.path
										+ "/KemaChat/theme.kthm "
										+ User.getHome()
										+ "/KemaChat/theme.kthm");
							} catch (Exception E) {

							}
							KemaChat.updateDesign();
							String next_name = user.getNickName().replaceAll(
									"\n", "");
							String next_design = user.getDesign().replaceAll(
									"\n", "");
							KFileManager.writeFile(User.getHome()
									+ "/KemaChat/design", design);
							message = "" + 123 + " " + 123 + " " + 123 + "\n"
									+ "Arial\n" + "\n" + "" + 0 + "\n" + "" + 1
									+ "\n" + "" + 0 + "\n" + ""
									+ MainUser.nickname + " [" + MainUser.name
									+ "] - " + getCurrentTime() + " Uhr:%_N\n"
									+ "" + 0 + " " + 0 + " " + 0 + "\n" + ""
									+ "Arial" + "\n" + "" + 1 + "\n" + "" + 1
									+ "\n" + "" + 1 + "\n" + "" + ""
									+ MainUser.nickname + " hat das Design ("
									+ next_design + ") kopiert, das von "
									+ next_name + " momentan verwendet wird."
									+ "%_N%_N";
							KemaChat.p("end of must copy");
						} else {
							String next_name = user.getNickName().replaceAll(
									"\n", "");
							String next_design = user.getDesign().replaceAll(
									"\n", "");
							message = "" + 123 + " " + 123 + " " + 123 + "\n"
									+ "Arial\n" + "\n" + "" + 0 + "\n" + "" + 1
									+ "\n" + "" + 0 + "\n" + ""
									+ MainUser.nickname + " [" + MainUser.name
									+ "] - " + getCurrentTime() + " Uhr:%_N\n"
									+ "" + 123 + " " + 123 + " " + 123 + "\n"
									+ "" + "Arial" + "\n" + "" + 1 + "\n" + ""
									+ 1 + "\n" + "" + 1 + "\n" + "" + ""
									+ MainUser.nickname + " hat das Design ("
									+ next_design + ") nicht kopiert, das von "
									+ next_name + " momentan verwendet wird."
									+ "%_N%_N";

							field.setText("");
						}
					}
					KemaChat.p("before send msg");
					KemaChat.sendMessage(message, user);
					KemaChat.p("after send msg");
					if (!user.isOnline()) {
						Message error_message = new Message();
						error_message.bold = 1;
						error_message.color = Color.RED;
						error_message.font_family = "Arial";
						error_message.text = "Die Nachricht konnte nicht gesendet werden,%_Nda "
								+ user.getName() + " nicht online ist.%_N%_N";
						insertFormattedText(error_message.getMessage());
					} else {
						insertFormattedText(KemaChat.formatText(message));
					}
					KemaChat.p("before setText");
					field.setText("");

					pane.scrollRectToVisible(new Rectangle(100000, 100000,
							100000, 100000));
				}
			}

			public void keyReleased(KeyEvent ke) {
				if (ke.getKeyChar() == '\n') {
					field.setText("");
				}
			}
		});

		addComponentListener(new ComponentAdapter() {
			public void componentResized(ComponentEvent arg0) {
				MainUser.chatframe_dimension = getSize();
				KemaChat.createUserData();
				pane_panel.img = Toolkit.getDefaultToolkit().getImage(
						User.getHome() + "/KemaChat/"
								+ MainUser.background_constant)
						.getScaledInstance(
								MainUser.chatframe_dimension.width - MainUser.avatar_size,
								MainUser.chatframe_dimension.height - 99,
								Image.SCALE_DEFAULT);
				pane_panel.repaint();
			}

			public void componentMoved(ComponentEvent e) {
				MainUser.chatframe_location = getLocation();
				KemaChat.createUserData();
			}
		});

		addFocusListener(new FocusAdapter() {
			public void focusGained(FocusEvent arg0) {
				field.requestFocus();
			}
		});
		tools.setBorderPainted(false);

		JPanel medium = new JPanel();
		medium.setLayout(null);

		JLabel label = new JLabel();
		// label.setBounds(0, 0, 800, 600);
		// label.setIcon(new ImageIcon("images/background1.jpg"));
		// label.setComponentZOrder(this,10);
		// add(label);
		label.setOpaque(false);
		// pane.setOpaque(false);
		// scroller.setOpaque(false);
		// scroller.getViewport().setOpaque(false);

		label.setBounds(0, 0, 1000, 1000);
		// scroller.setBounds(0,0,1000,1000);

		// medium.add(label);
		pane_panel.setLayout(new GridLayout(1, 1));
		pane.setOpaque(false);
		scroller.setOpaque(false);
		scroller.getViewport().setOpaque(false);
		pane_panel.add(scroller);
		c.add(pane_panel);

		// c.add(medium);

		// pane.setBorder(BorderFactory.createEmptyBorder(20, 20, 20, 20));
		writePanel.setLayout(new BorderLayout());
		writePanel.add(tools, BorderLayout.NORTH);
		writePanel.add(message_scroller);
		c.add(writePanel, BorderLayout.SOUTH);

		setVisible(true);
		field.requestFocus();
		MessageReader reader = new MessageReader();
		t_reader = new Thread(reader);
		pane.setEditable(false);

		KemaChat.p("End  init");

		init = true;
	}

	// end of init

	public SimpleAttributeSet getAttributeSet() {
		return set;
	}

	public void start() {

		KemaChat.p("Start reader");
		t_reader.start();

		KemaChat.p("End   reader");
	}

	public Document getDocument() {
		return document;
	}

	public String getCurrentTime() {
		GregorianCalendar cal = new GregorianCalendar();
		String hours = "" + cal.get(GregorianCalendar.HOUR_OF_DAY);
		String mins = "" + cal.get(GregorianCalendar.MINUTE);
		String secs = "" + cal.get(GregorianCalendar.SECOND);
		String hour = (hours.length() == 1) ? "0" + hours : hours;
		String min = (mins.length() == 1) ? "0" + mins : mins;
		String sec = (secs.length() == 1) ? "0" + secs : secs;
		return "" + hour + ":" + min + ":" + sec + "";
	}

	public String getCurrentFormattedTime() {
		GregorianCalendar cal = new GregorianCalendar();
		String hours = "" + cal.get(GregorianCalendar.HOUR_OF_DAY);
		String mins = "" + cal.get(GregorianCalendar.MINUTE);
		// String secs = "" + cal.get(GregorianCalendar.SECOND);
		String hour = (hours.length() == 1) ? "0" + hours : hours;
		String min = (mins.length() == 1) ? "0" + mins : mins;
		// String sec = (secs.length() == 1) ? "0" + secs : secs;
		return "" + hour + "." + min + "";
	}

	public String getCurrentDate() {
		GregorianCalendar cal = new GregorianCalendar();
		String hours = "" + cal.get(GregorianCalendar.DAY_OF_MONTH);
		String mins = "" + cal.get(GregorianCalendar.MONTH) + 1;
		String secs = "" + cal.get(GregorianCalendar.YEAR);
		String hour = (hours.length() == 1) ? "0" + hours : hours;
		String min = (mins.length() == 1) ? "0" + mins : mins;
		String sec = (secs.length() == 1) ? "0" + secs : secs;
		return "" + hour + "." + min + "." + sec + "";
	}

	public void saveHistory(boolean closeWindow) {
		String logpath = User.getHome() + "/Library/KemaChat/logs/CHAT_"
				+ user.getName() + "_" + getCurrentDate() + ".kemachat";
		File log1 = new File(logpath);
		/*
		 * int counter = 1; while(log1.exists()) { logpath =
		 * User.getHome()+"/Library/KemaChat/logs/CHAT_"+user.getName()+"_"+getCurrentDate()+"
		 * ("+getCurrentFormattedTime()+") "+counter+".kemachat"; log1 = new
		 * File(logpath); counter++; }
		 */
		if (log1.exists()) {
			String read = KFileManager.readFile(logpath);
			read = read.replaceAll("</BODY>\n", "");
			read = read.replaceAll("</HTML>\n", "");
			if (closeWindow) {
				read = read
						+ "\n"
						+ history
						+ "<FONT style=\"font-family: Arial; color: rgb(0, 0, 0)\"><B>Fenster um "
						+ getCurrentTime()
						+ " Uhr geschlossen.</B></FONT><BR><BR>\n";
			} else {
				read = read += history;
			}
			if (MainUser.save_history) {
				KFileManager.writeFile(logpath, read);
			}
		} else {
			String toWrite = history;
			toWrite = "<HTML>\n<HEAD>\n<TITLE>KemaChat History - "
					+ user.getName()
					+ "</TITLE>\n</HEAD>\n<BODY bgcolor=\"#FFFFFF\">\n"
					+ toWrite
					+ "<FONT style=\"font-family: Arial; color: rgb(0, 0, 0)\"><B>Fenster um "
					+ getCurrentTime()
					+ " Uhr geschlossen.</B></FONT><BR><BR>\n</BODY>\n</HTML>\n";
			if (MainUser.save_history) {
				KFileManager.writeFile(logpath, toWrite);
			}
		}
		HistoryViewer.updateLists();
	}

	public void deleteWindow() {
		killed = true;
		try {
			// t_scroll.interrupt();
			// t_focus.stop();
			// t_avatar.stop();
			// t_scroll.stop();
			// t_reader.interrupt();
			// t_reader.stop();
		} catch (Exception E) {

		}
		StringTokenizer st = new StringTokenizer(KemaChat.chatWith, " ");
		String exit = "";
		while (st.hasMoreTokens()) {
			String next = st.nextToken();
			if (!next.equals(user.getName())) {
				exit += "" + next + " ";
			}
		}
		KemaChat.p("KILLED DATA. Data is {" + exit + "}");
		saveHistory(true);
		chatwindow_space -= 20;

		KemaChat.chatWith = exit;
		KemaChat.loadUserData();
	}

	public void insertFormattedText(String text) {
		try {
			StringTokenizer st = new StringTokenizer(text, "\n");
			while (st.hasMoreTokens()) {
				/*
				 * Syntax:
				 * 
				 * 
				 * 
				 * 255 255 240
				 * 
				 * Arial
				 * 
				 * 0
				 * 
				 * 1
				 * 
				 * 0
				 * 
				 * hallo
				 * 
				 * 
				 * 
				 * color
				 * 
				 * fontfamily
				 * 
				 * normal(0)/bold(1)
				 * 
				 * normal(0)/italic(1)
				 * 
				 * normal(0)/underline(1)
				 * 
				 * message
				 */
				String nextLog = "";
				String s_color[] = st.nextToken().split(" ");
				Color color = new Color(Integer.parseInt(s_color[0]), Integer
						.parseInt(s_color[1]), Integer.parseInt(s_color[2]));
				String fontname = st.nextToken();
				int bold = Integer.parseInt(st.nextToken());
				int italic = Integer.parseInt(st.nextToken());
				int underline = Integer.parseInt(st.nextToken());
				String message = st.nextToken();
				String log_message = message;
				log_message = log_message.replaceAll("<", "&lt;");
				log_message = log_message.replaceAll(">", "&gt;");
				log_message = log_message.replaceAll("%_N", "<BR>");
				message = message.replaceAll("%_N", "\n");
				StyleConstants.setForeground(set, color);
				nextLog += "<FONT style=\"font-family: " + fontname
						+ "; color: rgb(" + color.getRed() + ", "
						+ color.getGreen() + ", " + color.getBlue() + ")\">";
				StyleConstants.setFontFamily(set, fontname);
				if (bold == 1) {
					nextLog += "<B>";
					StyleConstants.setBold(set, true);
				}
				if (italic == 1) {
					nextLog += "<I>";
					StyleConstants.setItalic(set, true);
				}
				if (underline == 1) {
					nextLog += "<U>";
					StyleConstants.setUnderline(set, true);
				}
				nextLog += "\n" + KemaChat.formatText(log_message, user) + "\n";
				if (bold == 1) {
					nextLog += "</B>";
				}
				if (italic == 1) {
					nextLog += "</I>";
				}
				if (underline == 1) {
					nextLog += "</U>";
				}
				nextLog += "</FONT>\n";
				KemaChat.p("bf. document.insert");
				document.insertString(document.getLength(), KemaChat
						.formatText(message, user), set);
				KemaChat.p("aft. document.insert");
				history += nextLog;
				// document.insertString(document.getLength(), message, set);
				// JLabel c = new JLabel("mytext");
				// StyleConstants.setComponent(smilies, c);
				// document.insertString(document.getLength(), "abc", smilies);
				killStyleConstants();
			}
		} catch (Exception E) {
			E.printStackTrace();
		}
	}

	public void killStyleConstants() {
		StyleConstants.setBold(set, false);
		StyleConstants.setForeground(set, new Color(0, 0, 0));
		StyleConstants.setItalic(set, false);
		StyleConstants.setUnderline(set, false);

	}
}

class Pane extends JComponent {
	private static final long serialVersionUID = 1L;

	public JTextPane pane = new JTextPane();

	public Image img = Toolkit.getDefaultToolkit().getImage(
			User.getHome() + "/KemaChat/" + MainUser.background_constant)
			.getScaledInstance(MainUser.chatframe_dimension.width - MainUser.avatar_size,
					MainUser.chatframe_dimension.height - 99,
					Image.SCALE_DEFAULT);

	public void paintComponent(Graphics g) {

		// .getScaledInstance((int)pane.getSize().getWidth() - 600,
		// (int)pane.getSize().getHeight()-600, Image.SCALE_DEFAULT);

		g.drawImage(img, 0, 0, pane);
		// pane.paint(g);
	}

}