import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Container;
import java.io.File;

import javax.swing.DefaultListModel;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextPane;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

import kemachat.MainUser;
import kwt.DialogMessage;
import kwt.User;

public class HistoryViewer {
	public static JFrame frame;

	public static JList user_list;

	public static JList data_list;

	public static DefaultListModel model_user;

	public static DefaultListModel model_data;

	public static JButton close;

	public static JTextPane log_area;

	public static Container c;

	public static JPanel user_list_panel;

	public static JPanel main_panel;

	public static JLabel info_user_list;

	public static void init() {
		frame = new JFrame("History - KemaChat");
		frame.setSize(600, 500);
		frame.setLocation(300, 200);
		c = frame.getContentPane();
		model_user = new DefaultListModel();
		model_data = new DefaultListModel();
		user_list = new JList(model_user);
		data_list = new JList(model_data);
		user_list.setBackground(new Color(240, 240, 255));
		close = new JButton("<html><b>Fenster schliessen</b></html>");
		info_user_list = new JLabel("<html><b>User:</b></html>");
		user_list_panel = new JPanel();
		main_panel = new JPanel();
		user_list_panel.setLayout(new BorderLayout());
		main_panel.setLayout(new BorderLayout());
		user_list_panel.add(info_user_list, BorderLayout.NORTH);
		user_list_panel.add(new JScrollPane(user_list), BorderLayout.CENTER);
		log_area = new JTextPane();
		log_area.setEditable(false);
		main_panel.add(new JScrollPane(data_list), BorderLayout.NORTH);
		main_panel.add(new JScrollPane(log_area), BorderLayout.CENTER);
		c.add(user_list_panel, BorderLayout.WEST);
		c.add(main_panel, BorderLayout.CENTER);
		c.add(close, BorderLayout.SOUTH);
		KemaChat.addWindowCloseButtonEvent(close, frame);
		updateLists();
		user_list.addListSelectionListener(new ListSelectionListener() {
			public void valueChanged(ListSelectionEvent e) {
				updateDate();
			}
		});
		data_list.addListSelectionListener(new ListSelectionListener() {
			public void valueChanged(ListSelectionEvent e) {
				updateHistory();
			}
		});
	}

	public static void updateLists() {
		model_user.removeAllElements();
		for (int i = 0; i < MainUser.userlist.length; i++) {
			if (logExists(MainUser.userlist[i])) {
				model_user.addElement("<html><b>" + MainUser.userlist[i]
						+ "</b></html>");
			}
		}
		user_list.setSelectedIndex(0);
		if (model_user.getSize() != 0)
			updateDate();
	}

	public static void showHistory(String username) {
		frame.setVisible(true);
		if (!username.equals("")) {
			user_list.setSelectedValue("<html><b>" + username + "</b></html>",
					true);
		}
	}

	public static void updateDate() {
		String username = "";
		if (user_list.getSelectedIndex() == -1) {
			return;
		} else {
			try {
				username = user_list.getSelectedValue().toString().toLowerCase();
			} catch(ArrayIndexOutOfBoundsException E) {
				KemaChat.p("EXCEPTION WHILE DELETING HISTORY. (USUAL IN VERSION 2.4). HISTORY DELETED ANYWAY.");
				return;
			}
		}
		username = username.replaceAll("<html>", "");
		username = username.replaceAll("</html>", "");
		username = username.replaceAll("<b>", "");
		username = username.replaceAll("</b>", "");
		model_data.removeAllElements();
		File log_file[] = new File(User.getHome() + "/Library/KemaChat/logs/")
				.listFiles();
		for (int i = 0; i < log_file.length; i++) {
			String next = log_file[i].toString().toLowerCase();
			next = next.substring(next.lastIndexOf("/") + 1, next.length());
			if (next.startsWith("chat_" + username + "_")) {
				String data = next.substring(username.length() + 6, next
						.lastIndexOf("."));
				model_data.addElement(username + " - " + data + "");
			}
		}
		data_list.setSelectedIndex(0);
		if (model_data.getSize() > 0)
			updateHistory();
	}

	public static void updateHistory() {
		String username = user_list.getSelectedValue().toString().toLowerCase();
		username = username.replaceAll("<html>", "");
		username = username.replaceAll("</html>", "");
		username = username.replaceAll("<b>", "");
		username = username.replaceAll("</b>", "");
		String date = "";
		if (data_list.getSelectedValue() == null) {
			return;
		} else {
			date = data_list.getSelectedValue().toString().toLowerCase();
		}
		date = date.substring(date.lastIndexOf("- ") + 2, date.length());
		File log_file = new File(User.getHome()
				+ "/Library/KemaChat/logs/CHAT_" + username + "_" + date
				+ ".kemachat");
		try {
			String url = "file://" + log_file.getAbsolutePath();
			log_area.setPage(url);
		} catch (Exception E) {
			DialogMessage.error("Die History Datei wurde nicht gefunden!");
		}
	}

	public static void delete() {
		File log_file[] = new File(User.getHome() + "/Library/KemaChat/logs/")
				.listFiles();
		for (int i = 0; i < log_file.length; i++) {
			log_file[i].delete();
		}
//		model_data.removeAllElements();
//		model_user.removeAllElements();
//		log_area.setText("");
		boolean mustShow = frame.isVisible();
		frame.setVisible(false);
		init();
		frame.setVisible(mustShow);
	}

	public static boolean logExists(String username) {
		File log_file[] = new File(User.getHome() + "/Library/KemaChat/logs/")
				.listFiles();
		username = username.toLowerCase();
		for (int i = 0; i < log_file.length; i++) {
			String next = log_file[i].toString().toLowerCase();
			next = next.substring(next.lastIndexOf("/") + 1, next.length());
			if (next.startsWith("chat_" + username + "_")) {
				return true;
			}
		}
		return false;
	}
}
