import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Container;
import java.awt.Cursor;
import java.awt.Font;
import java.awt.GridLayout;
import java.awt.Image;
import java.awt.Toolkit;
import java.awt.Window;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.image.BufferedImage;
import java.io.File;

import javax.imageio.ImageIO;
import javax.swing.BorderFactory;
import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JProgressBar;
import javax.swing.JScrollPane;
import javax.swing.JToolBar;

import kemachat.MainUser;
import kwt.DialogMessage;
import kwt.KPreferencesPane;
import kwt.User;

public class ImageChooser extends JFrame {
	private static final long serialVersionUID = 1L;

	public String image_name = "";

	public Container c = getContentPane();

	public JToolBar toolbar = new JToolBar();

	public JPanel img_list = new JPanel();

	public JButton l_add = new JButton("<html>Bild hinzuf&uuml;gen</html>",
			new ImageIcon(Toolkit.getDefaultToolkit().getImage(
					"images/icons/plus.png").getScaledInstance(64, 64,
					Image.SCALE_DEFAULT)));

	public JButton l_delete = new JButton("<html>Bild l&ouml;schen</html>",
			new ImageIcon(Toolkit.getDefaultToolkit().getImage(
					"images/icons/minus.png").getScaledInstance(64, 64,
					Image.SCALE_DEFAULT)));

	public JButton l_save = new JButton("<html>Bild &uuml;bernehmen</html>",
			new ImageIcon(Toolkit.getDefaultToolkit().getImage(
					"images/icons/save.png").getScaledInstance(64, 64,
					Image.SCALE_DEFAULT)));

	public int selected = -1;

	public JLabel next_image[] = new JLabel[200];

	public String image_url[] = new String[200];

	public int image_count = 0;
	
	public double size_factor = 2;
	
	public int screen_width = Toolkit.getDefaultToolkit().getScreenSize().width;
	public int screen_height = Toolkit.getDefaultToolkit().getScreenSize().height;

	public ImageChooser() {
		super();	
		setSize((int) (screen_width / size_factor) + 40, screen_height);
		setLocation((int) ((screen_width - (screen_width / size_factor)) / 2),
				0);
		toolbar.setBorderPainted(false);
		c.add(toolbar, BorderLayout.NORTH);
		c.add(new JScrollPane(img_list));
		toolbar.add(l_save);
		toolbar.add(l_add);
		toolbar.add(l_delete);
		l_add.setBorder(null);
		l_delete.setBorder(null);
		l_save.setBorder(BorderFactory.createEmptyBorder(3, 3, 3, 3));
		l_delete.setBorder(BorderFactory.createEmptyBorder(3, 3, 3, 3));
		l_add.setBorder(BorderFactory.createEmptyBorder(3, 3, 3, 3));
		l_add.setCursor(new Cursor(Cursor.HAND_CURSOR));
		l_delete.setCursor(new Cursor(Cursor.HAND_CURSOR));
		l_save.setCursor(new Cursor(Cursor.HAND_CURSOR));

		l_save.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ae) {
				l_save.setEnabled(false);
				l_delete.setEnabled(false);
				l_add.setEnabled(false);
				l_save.setBorder(BorderFactory.createLineBorder(Color.BLACK, 3));
				final Window wait_window = new Window( new JFrame());
				wait_window.setSize((int) ((screen_width / size_factor) + 40)/2, 100);
				wait_window.setLocation((int)(screen_width - (screen_width / size_factor)+((screen_width / size_factor) + 40)/2) / 2, 300);
				final JProgressBar progress = new JProgressBar(0, 30);
				progress.setStringPainted(true);
				progress.setFont(new Font("Sans serif", Font.BOLD, 14));
				final JLabel progress_info = new JLabel("<html><b>Hintergrund wird gespeichert...</b></html>");
				wait_window.add(progress_info, BorderLayout.NORTH);
				wait_window.add(progress);
				wait_window.setVisible(true);
				new Thread( new Runnable() {
					public void run() {
						progress.setValue(1);
						File new_file = new File(image_url[selected]);
						progress.setValue(2);
						File old_background = new File(User.getHome()+"/KemaChat/"+MainUser.background_constant);
						progress.setValue(3);
						old_background.delete();
						progress.setValue(4);
						MainUser.background_constant = "background"+Math.round(Math.random()*10000)+".png";
						progress.setValue(5);
						String newloc = User.getHome() + "/KemaChat/"+MainUser.background_constant;
						progress.setValue(6);
						try {
							BufferedImage i = ImageIO.read(new_file);
							progress.setValue(10);
							if (new_file.toString().toLowerCase().endsWith(".png")) {
								ImageIO.write(i, "PNG", new File(newloc));
							} else {
								ImageIO.write(i, "JPG", new File(newloc));
							}
							progress.setValue(15);
						} catch (Exception E) {
							wait_window.setVisible(false);
							E.printStackTrace();
							DialogMessage
									.error("Ein unbekannter Fehler ist aufgetreten.");
						}
						progress.setValue(16);
						MainUser.background = new_file.toString();
						progress.setValue(17);
						try {
							Icon avatar_icon = new ImageIcon(ImageIO.read(
									new File(User.getHome()+"/KemaChat/"+MainUser.background_constant))
									.getScaledInstance(676, 498, Image.SCALE_DEFAULT));
							progress.setValue(20);
							KemaChat.bgimage_panel.setIcon(avatar_icon);
							progress.setValue(22);
						} catch (Exception E) {
							E.printStackTrace();
						}
						progress.setValue(23);
						KemaChat.mustRepaintBackground = true;
						progress.setValue(24);
						for(int i=0;i<KemaChat.chatnumber;i++) {
							try {
								KemaChat.chat_windows[i].pane_panel.img = Toolkit.getDefaultToolkit().getImage(User.getHome()+"/KemaChat/"+MainUser.background_constant).getScaledInstance(MainUser.chatframe_dimension.width-MainUser.avatar_size, MainUser.chatframe_dimension.height-99, Image.SCALE_DEFAULT);
								KemaChat.chat_windows[i].pane_panel.repaint();
								KPreferencesPane.main.setVisible(true);
							} catch(Exception E) {
								E.printStackTrace();
								DialogMessage.error("<font size=5>KEMACHAT DEBUG MODE: ERROR</font><br><br>KemaChat.chat_windows["+i+"] is null.");
								break;
							}
						}
						progress.setValue(27);
						KemaChat.createUserData();
						progress.setValue(28);
						setVisible(false);
						progress.setValue(29);
						select(MainUser.background);
						progress.setValue(30);
						wait_window.setVisible(false);
						l_save.setBorder(BorderFactory.createEmptyBorder(3, 3, 3, 3));
						l_save.setEnabled(true);
						l_delete.setEnabled(true);
						l_add.setEnabled(true);
					}
				}).start();
				
			}
		});

		l_delete.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ae) {
				l_delete.setBorder(BorderFactory.createLineBorder(Color.BLACK, 3));
				if (DialogMessage
						.warning_confirm("Sind Sie sicher, dass Sie das ausgew&auml;hlte Bild l&ouml;schen wollen?") == 0) {
					File toDelete = new File(image_url[selected]);
					toDelete.delete();
					reload();
				}
				l_delete.setBorder(BorderFactory.createEmptyBorder(3, 3, 3, 3));
			}
		});
		l_add.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ae) {
				l_add.setBorder(BorderFactory.createLineBorder(Color.BLACK, 3));
				JFileChooser file_chooser = new JFileChooser();
				javax.swing.filechooser.FileFilter filter = new javax.swing.filechooser.FileFilter() {
					public boolean accept(File pathname) {
						String filename = pathname.toString().toLowerCase();
						return filename.endsWith(".jpg")
								|| filename.endsWith(".jpeg")
								|| filename.endsWith(".png")
								|| filename.endsWith(".gif")
								|| pathname.isDirectory();
					}

					public String getDescription() {
						return "Bilddateien (*.JPG, *.JPEG, *.PNG, *.GIF)";
					}
				};
				file_chooser.setFileFilter(filter);
				file_chooser.setSelectedFile(new File(User.getHome()
						+ "/Pictures/"));
				file_chooser.showOpenDialog(null);
				File new_file = file_chooser.getSelectedFile();
				if (new_file == null) {
					l_add.setBorder(BorderFactory.createEmptyBorder(3, 3, 3, 3));
					return;
				}
				if (new_file.isDirectory()) {
					l_add.setBorder(BorderFactory.createEmptyBorder(3, 3, 3, 3));
					return;
				}
				String filename = new_file.toString();
				if (!filename.toLowerCase().endsWith(".png")
						&& !filename.toLowerCase().endsWith(".jpg")
						&& !filename.toLowerCase().endsWith(".jpeg")
						&& !filename.toLowerCase().endsWith(".gif")) {
					DialogMessage
							.error("Die ausgew&auml;hlte Datei ist keine g&uuml;ltige Bilddatei.");
					l_add.setBorder(BorderFactory.createEmptyBorder(3, 3, 3, 3));
					return;
				}
				filename = filename.substring(filename.lastIndexOf("/") + 1,
						filename.length());
				String newloc = User.getHome() + "/KemaChat/backgrounds/"
						+ filename;
				if (new File(newloc).exists()) {
					if (DialogMessage
							.warning_confirm("Ein Bild mit diesem Namen existiert in der Bildergallerie bereits. Wollen Sie das Bild &uuml;berschreiben?") != 0) {
						l_add.setBorder(BorderFactory.createEmptyBorder(3, 3, 3, 3));
						return;
					}
				}
				try {
					BufferedImage i = ImageIO.read(new_file);
					if (new_file.toString().toLowerCase().endsWith(".png")) {
						ImageIO.write(i, "PNG", new File(newloc));
					} else {
						ImageIO.write(i, "JPG", new File(newloc));
					}
				} catch (Exception E) {
					E.printStackTrace();
					DialogMessage
							.error("Ein unbekannter Fehler ist aufgetreten.");
				}
				reload();
				select(newloc);
				l_add.setBorder(BorderFactory.createEmptyBorder(3, 3, 3, 3));
			}
		});
		reload();
	}

	public void visible() {
		if (MainUser.background.equals("")) {
			select(0);
		} else {
			select(MainUser.background);
		}
		setVisible(true);
	}

	public String getImage() {
		return image_name;
	}

	public void reload() {
		img_list.removeAll();
		image_count = 0;
		File bgs[] = new File(User.getHome() + "/KemaChat/backgrounds/")
				.listFiles();
		img_list.setLayout(new GridLayout(bgs.length / 4 + 1, 1));
		if (bgs.length < 5) {
			img_list.setLayout(new GridLayout(5, 1));
		}
		int real_count = 0;
		for (int i = 0; i < bgs.length; i++) {
			JPanel next_panel = new JPanel();
			for (int b = 0; b < 4; b++) {
				if (i + b + real_count >= bgs.length)
					break;
				final File next = bgs[i + b + real_count];
				if (next.toString().toLowerCase().endsWith(".png")
						|| next.toString().toLowerCase().endsWith(".jpg")
						|| next.toString().toLowerCase().endsWith(".jpeg")
						|| next.toString().toLowerCase().endsWith(".gif")) {
					next_image[image_count] = new JLabel(new ImageIcon(Toolkit
							.getDefaultToolkit().getImage(next.toString())
							.getScaledInstance(150, 115, Image.SCALE_DEFAULT)));
					next_panel.add(next_image[image_count]);
					final int _image_count = image_count;
					next_image[image_count]
							.addMouseListener(new MouseAdapter() {
								public void mousePressed(MouseEvent me) {
									select(_image_count);
								}
							});
					image_url[image_count] = next.getAbsolutePath();
					String filename = image_url[image_count];
					filename = filename.substring(
							filename.lastIndexOf("/") + 1, filename.length());
					if (filename.toLowerCase().endsWith(".png")
							|| filename.toLowerCase().endsWith(".jpg")
							|| filename.toLowerCase().endsWith(".gif")) {
						filename = filename.substring(0, filename.length() - 4);
					} else if (filename.toLowerCase().endsWith(".jpeg")) {
						filename = filename.substring(0, filename.length() - 5);
					}
					next_image[image_count].setToolTipText(filename);
					if(KemaChat.loader.isVisible()) {
						KemaChat.setProgressValue(10, "Lade Bildergallerie <font size=2>(Bild "+filename+")</font>...");
					}
					image_count++;
				} else {
					real_count++;
					b--;
				}
			}
			img_list.add(next_panel);
			i = i + 3;
		}
		if (MainUser.background.equals("")) {
			select(0);
		} else {
			select(MainUser.background);
		}
		if (image_count == 0) {
			l_save.setEnabled(false);
			l_delete.setEnabled(false);
		} else {
			l_save.setEnabled(true);
			l_delete.setEnabled(true);
		}
		if (isVisible()) {
			setVisible(false);
			setVisible(true);
		}
	}

	public void select(int index) {
		selected = index;
		for (int i = 0; i < image_count; i++) {
			if (i == index) {
				next_image[i].setBorder(BorderFactory.createLineBorder(
						Color.BLACK, 3));
			} else {
				next_image[i].setBorder(BorderFactory.createEmptyBorder(3, 3,
						3, 3));
			}
		}
	}

	public void select(String name) {
		for (int i = 0; i < image_count; i++) {
//			KemaChat.p("image_url[i]="+image_url[i]+"; name="+name+";");
			if (image_url[i].equals(name)) {
				select(i);
				return;
			}
		}
		KemaChat.p("is nothing");
		// If "name" was not found (no break in the for):
		select(0);
	}

	public void setImage(String name) {
		image_name = name;
	}
}
