import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Container;
import java.awt.Cursor;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.Frame;
import java.awt.GraphicsEnvironment;
import java.awt.GridLayout;
import java.awt.Image;
import java.awt.Menu;
import java.awt.MenuBar;
import java.awt.MenuItem;
import java.awt.MenuShortcut;
import java.awt.Point;
import java.awt.Toolkit;
import java.awt.Window;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ComponentAdapter;
import java.awt.event.ComponentEvent;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.FileInputStream;
import java.util.StringTokenizer;

import javax.imageio.ImageIO;
import javax.swing.BorderFactory;
import javax.swing.ButtonGroup;
import javax.swing.DefaultListModel;
import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JColorChooser;
import javax.swing.JComboBox;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JMenuItem;
import javax.swing.JPanel;
import javax.swing.JPopupMenu;
import javax.swing.JProgressBar;
import javax.swing.JRadioButton;
import javax.swing.JScrollPane;
import javax.swing.JSlider;
import javax.swing.JTextField;
import javax.swing.JToolBar;
import javax.swing.UIManager;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import javax.swing.plaf.metal.MetalTheme;

import kemachat.ChatUser;
import kemachat.KUserFileManager;
import kemachat.MainUser;
import kwt.DialogMessage;
import kwt.GUIManager;
import kwt.KButton;
import kwt.KFileManager;
import kwt.KPreferencesPane;
import kwt.KTabbedPane;
import kwt.KemaApplication;
import kwt.Sound;
import kwt.Updater;
import kwt.User;
import laf.AquaMetalTheme;
import laf.BigContrastMetalTheme;
import laf.ContrastMetalTheme;
import laf.DarkMetalTheme;
import laf.DemoMetalTheme;
import laf.GreenMetalTheme;
import laf.KemaPinkTheme;
import laf.KhakiMetalTheme;
import laf.PropertiesMetalTheme;

import com.apple.eawt.Application;
import com.apple.eawt.ApplicationEvent;
import com.apple.eawt.ApplicationListener;

/**
 * 
 * 
 * @author Matteo Pagamici
 * 
 * Copyright (c) 2006 Matteo Pagamici All rights reserved
 * 
 * All default themes are written by Sun Microsystems
 * 
 * More info on http://www.rossoforte.ch/kema/
 * 
 */

public class KemaChat {
	public static JComboBox designs;

	public static JLabel info_text;

	public static boolean mustRepaintBackground = false;

	public static JLabel bgimage_panel;

	public static JFrame main_frame;

	public static ImageChooser chooser;

	public static Color thecolor;

	public JToolBar main_toolbar;

	public static KPreferencesPane pref;

	public static JLabel userwriter[] = new JLabel[100];

	public static boolean nextoffline[] = new boolean[100];

	public static JTextField t_userpath;

	public static boolean isover[] = new boolean[100];

	public static String focusto = "";

	public static String design = "";

	public static JTextField contactname;

	public static JLabel progress_text;

	public static JProgressBar progress;

	public static Window loader;

	public static JLabel addfirstuser;

	public static ChatWindow chat_windows[] = new ChatWindow[100];

	// public static ChatUser thisuser = new ChatUser("");

	// public static File last_file = new File();

	public static int window_count = 0;

	public static JFrame newcontact;

	public static int scaler = 1;

	public static File avatar_file = new File(User.getHome()
			+ "/KemaChat/avatar.jpg");

	public static String chatWith = "";

	public static Image bgimage;

	public static String userdata_location = User.getHome()
			+ "/Library/KemaChat/userdata";

	public static String contactlist_location = User.getHome()
			+ "/KemaChat/contactlist";

	public Container c;

	public static int pref_index = 0;

	public static String log_location = User.getHome()
			+ "/Library/KemaChat/logs/";

	public static JPanel contact_list;

	public static JLabel title_online;

	public static JLabel title_offline;

	public static String[] users_online = new String[500];

	public static String[] users_offline = new String[500];

	public MenuBar menubar;

	public Menu contacts;

	public MenuItem addnewcontact;

	public Menu window;

	public MenuItem closewindow;

	public MenuItem showHistory;

	public Menu help;

	public MenuItem ask_question;

	public JScrollPane scroll_contactlist;

	public static int chatnumber = 0;

	public static JComboBox font;

	public static JLabel nickname;

	// public static KButton avatar;

	public static JLabel avatar;

	public static KemaApplication app = new KemaApplication();

	public String isNewMessage() {
		/*
		 * Checks if some user has sent a message to you. If yes, it checks if
		 * there is already a chatwindow with that user. If there is one, it
		 * tells the chatwindow to focus (it does not focus it!). If there isn't
		 * a chatwindow with that user, it calls chat($user).
		 */
		String returner = "";
		File list[] = new File(User.getHome() + "/Public/Drop Box/")
				.listFiles();
		for (int i = 0; i < list.length; i++) {
			String next = list[i].toString();
			next = next.substring(next.lastIndexOf("/") + 1, next.length());
			if (next.toLowerCase().startsWith("message_")) {
				String username = next.substring(8, next.lastIndexOf("_"));
				ChatUser nextuser = new ChatUser(username);
				String list_now = KUserFileManager
						.readFile(contactlist_location);
				if (MainUser.allow == 1
						|| list_now.indexOf(username + "\n") != -1) {
					if (MainUser.sound_play_newmessage) {
						Sound to_play = new Sound("sounds/"
								+ MainUser.sound_newmessage + ".aif");
						to_play.play();
					}
					chat(nextuser);
					returner = "user:" + username + "";
				} else if (MainUser.allow == 0) {
					list[i].delete();
				}
			}
		}
		return returner;
	}

	public static boolean isAdmin() {
		/*
		 * Creates a file in the application bundle. If the file can be created,
		 * you are administrator of the application bundle, you're administrator
		 * of the computer if the application bundle is in the applications
		 * folder.
		 */
		if (KFileManager.writeFile("admintest", "admintest")) {
			new File("admintest").delete();
			return true;
		} else {
			return false;
		}
	}

	public static void setProgressValue(int percent, String text) {
		/*
		 * Changes the value of the progressbar. Is called only while the load
		 * process.
		 */
		progress.setValue(percent);
		progress.setString("" + percent + "%");
		progress.setFont(new Font("Sans serif", Font.BOLD, 14));
		progress_text
				.setText("<html><b><br><font size=5>&nbsp;&nbsp;&nbsp;&nbsp;"
						+ text + "</font></b></html>");
	}

	public static String themes[] = { "Metal", "Metal Green", "Metal Aqua",
			"Metal Khaki", "Metal Contrast", "Brush Metal", "Mac Design",
			"Kema Dark Metal", "Kema Pink" };

	/*
	 * DISABLED THEMES:
	 * 
	 * Metal Demo Metal Big Contrast
	 * 
	 */

	public static void updateDesign() {
		/*
		 * Changes the LAF of the application. To see the new LAF completly, an
		 * application restart is needed.
		 */
		if (design.endsWith(".kthm")) {
			try {
				MetalTheme special_design = new PropertiesMetalTheme(
						new FileInputStream(User.getHome()
								+ "/KemaChat/theme.kthm"));
				System.setProperty("sun.awt.noerasebackground.png", "true");
				javax.swing.plaf.metal.MetalLookAndFeel
						.setCurrentTheme(special_design);
			} catch (Exception E) {
				design = "Mac Design";
			}
		} else if (design.equals("Mac Design")) {
		} else if (design.equals("Metal")) {
			System.setProperty("sun.awt.noerasebackground", "true");
			javax.swing.plaf.metal.MetalLookAndFeel
					.setCurrentTheme(new javax.swing.plaf.metal.DefaultMetalTheme());

		} else if (design.equals("Metal Green")) {
			System.setProperty("sun.awt.noerasebackground", "true");
			javax.swing.plaf.metal.MetalLookAndFeel
					.setCurrentTheme(new GreenMetalTheme());
		} else if (design.equals("Metal Aqua")) {
			System.setProperty("sun.awt.noerasebackground", "true");
			javax.swing.plaf.metal.MetalLookAndFeel
					.setCurrentTheme(new AquaMetalTheme());
		} else if (design.equals("Metal Khaki")) {
			System.setProperty("sun.awt.noerasebackground", "true");
			javax.swing.plaf.metal.MetalLookAndFeel
					.setCurrentTheme(new KhakiMetalTheme());
		} else if (design.equals("Kema Dark Metal")) {
			System.setProperty("sun.awt.noerasebackground", "true");
			javax.swing.plaf.metal.MetalLookAndFeel
					.setCurrentTheme(new DarkMetalTheme());
		} else if (design.equals("Metal Demo")) {
			System.setProperty("sun.awt.noerasebackground", "true");
			javax.swing.plaf.metal.MetalLookAndFeel
					.setCurrentTheme(new DemoMetalTheme());
		} else if (design.equals("Metal Contrast")) {
			System.setProperty("sun.awt.noerasebackground", "true");
			javax.swing.plaf.metal.MetalLookAndFeel
					.setCurrentTheme(new ContrastMetalTheme());
		} else if (design.equals("Metal Big Contrast")) {
			System.setProperty("sun.awt.noerasebackground", "true");
			javax.swing.plaf.metal.MetalLookAndFeel
					.setCurrentTheme(new BigContrastMetalTheme());
		} else if (design.equals("Kema Pink")) {
			System.setProperty("sun.awt.noerasebackground", "true");
			javax.swing.plaf.metal.MetalLookAndFeel
					.setCurrentTheme(new KemaPinkTheme());
		} else {
			design = "Brush Metal";
			GUIManager.setBrushMetalLook(true);
		}
		if (!design.equals("Brush Metal") && !design.equals("Mac Design")) {
			try {
				UIManager
						.setLookAndFeel("javax.swing.plaf.metal.MetalLookAndFeel");
			} catch (Exception E) {

			}
		}
	}

	public KemaChat() {

		/*
		 * Creates the public user data folder, if it does not exist. The same
		 * with all others public user datas.
		 */
		File kemachat_dir = new File(User.getHome() + "/KemaChat/");
		if (!kemachat_dir.exists()) {
			kemachat_dir.mkdir();
		}
		kemachat_dir = new File(User.getHome() + "/Library/KemaChat/");
		if (!kemachat_dir.exists()) {
			kemachat_dir.mkdir();
		}
		File design_file = new File(User.getHome() + "/KemaChat/design");
		if (!design_file.exists()) {
			KFileManager.writeFile(User.getHome() + "/KemaChat/design",
					"Brush Metal");
		}
		design = KFileManager.readFile(User.getHome() + "/KemaChat/design");
		design = design.replaceAll("\n", "");
		try {
			// MetalTheme myTheme = new PropertiesMetalTheme(new
			// FileInputStream(
			// "MyTheme.kct"));
			/*
			 * Themes: MetalTheme[] themes = { new DefaultMetalTheme(), new
			 * GreenMetalTheme(), new AquaMetalTheme(), new KhakiMetalTheme(),
			 * new DemoMetalTheme(), new ContrastMetalTheme(), new
			 * BigContrastMetalTheme(), myTheme, new KemaMetalTheme() };
			 */
		} catch (Exception E) {

		}
		updateDesign();
		KFileManager.writeFile(User.getHome() + "/KemaChat/design", design);

		File log_file = new File(User.getHome() + "/Library/KemaChat/logs/");
		if (!log_file.exists()) {
			log_file.mkdirs();
		}

		// String bg_newloc = User.getHome() + "/KemaChat/background.png";
		// File bg_file = new File(bg_newloc);
		// try {
		// BufferedImage i = ImageIO.read(new File("images/background1.jpg"));
		// ImageIO.write(i, "JPG", bg_file);
		// } catch (Exception E) {
		// E.printStackTrace();
		// }
		/*
		 * Informations about the application.
		 */
		app.version = "2.4";
		app.full_version = "2.4.3";
		app.release_date = "27. January 2007";
		app.beta = false;
		app.title = "KemaChat";
		app.name = "KemaChat";
		app.author = "Matteo Pagamici";
		app.price = "freeware";
		app.url_name = "kemachat";
		app.system = "Mac";
		app.system = "OS X 10.4";
		app.tested_system = "Mac OS X 10.4";
		app.executable_file = "KemaChat_2_4.jar";
		/*
		 * If there is no avatar, create one (kemachat icon; file
		 * "images/noava.png").
		 */
		String newloc = User.getHome() + "/KemaChat/avatar.jpg";
		File av_file = new File(newloc);
		if (!av_file.exists()) {
			try {
				BufferedImage i = ImageIO.read(new File("images/noava.png"));
				ImageIO.write(i, "PNG", av_file);
			} catch (Exception E) {
				E.printStackTrace();
			}
		}

		/*
		 * Checks if there is a new version of kemachat in the internet.
		 */
		Updater up = new Updater("KemaChat 2.4", "kemachat");
		if (isAdmin() && !up.version.equals("")) {
			/*
			 * If you can write in the application bundle, you can update.
			 */
			if (!up.version.equals(app.version)) {
				p("There is a new version of KemaChat (" + up.version
						+ "). Can update.");
				int shallOpenPage = DialogMessage
						.confirm(

								"<html><b>Eine neue Version von KemaChat steht zur Verf&uuml;gung. Wollen KemaChat jetzt updaten?<br><br>Folgendes &uuml;ber die neue Version des Programms:</b><br><br><br><b>Jetzige Programm Version:</b><br>"
										+ app.version
										+ "<br><br><b>Neue Version:</b><br>"
										+ up.version
										+ "<br><br><b>Neue Features:</b>"
										+ up.features, "Neue Version");
				if (shallOpenPage == 0) {
					up.update();
					File propertylist_file = new File("../../Info.plist");
					if (propertylist_file.exists()) {
						String read = KFileManager.readFile("../../Info.plist");
						read = read
								.replaceAll(app.executable_file, up.filename);
						read = read.replaceAll(app.version, up.version);
						KFileManager.writeFile("../../Info.plist", read);
						System.out.println(read);
						DialogMessage
								.message("Das Programm wurde von Version "
										+ app.version
										+ " zu Version "
										+ up.version
										+ " upgedatet.<br>KemaChat wird jetzt beendet. Bitte starten Sie es neu.");
						p("Updated and exited.");
						System.exit(0);
					} else {
						DialogMessage
								.error("Fehler beim Updaten: die Datei <i>Info.plist</i> konnte nicht gefunden werden.");
						File toDelete = new File(up.filename);
						toDelete.delete();
					}

				}
			}

		} else {
			/*
			 * You cannot write in the application bundle, the application is
			 * probably in the application folder.
			 */
			if (!up.version.equals(app.version)) {
				p("There is a new Version of KemaChat (" + app.version
						+ "), but cannot update, permission denied.");
			} else {
				p("There are no new versions, and could not update, permission denied.");
			}
		}
		class MessageController implements Runnable {
			/*
			 * Checks every 0.5 seconds if there is a new message waiting for
			 * you (isNewMessage()). Waits 1 second at the beginning.
			 */
			public void run() {
				try {
					Thread.sleep(1000);
					while (true) {

						isNewMessage();

						Thread.sleep(500);

					}
				} catch (Exception E) {
					E.printStackTrace();
				}
			}
		}
		class UserAddController implements Runnable {
			/*
			 * 
			 * If somebody adds you to his contactlist.
			 */
			public void run() {
				try {
					Thread.sleep(1000);
					while (true) {

						checkNewUser();

						Thread.sleep(1000);

					}
				} catch (Exception E) {
					E.printStackTrace();
				}
			}
		}
		progress_text = new JLabel(
				"<html><b><font size=5><br><br>&nbsp;&nbsp;&nbsp;&nbsp;Ladevorgang...</font></b></html>");
		loader = new Window(new Frame());
		loader.setLocation(300, 300);
		loader.setSize(500, 100);
		progress = new JProgressBar(0, 100);
		loader.add(progress);
		loader.add(progress_text, BorderLayout.NORTH);
		loader.setVisible(true);
		progress.setStringPainted(true);

		File gallery_dir = new File(User.getHome() + "/KemaChat/backgrounds/");
		if (!gallery_dir.exists() || !gallery_dir.isDirectory()) {
			gallery_dir.mkdirs();
		}
		/*
		 * Checks if has to install the image gallery.
		 */
		File bg_files[] = new File("images/backgrounds/").listFiles();
		boolean found = false;
		if (new File("images/backgrounds/").exists()) {
			for (int i = 0; i < bg_files.length; i++) {
				String next = bg_files[i].toString();
				String next_name = next.substring(next.lastIndexOf("/") + 1,
						next.length());
				File user_image = new File(User.getHome()
						+ "/KemaChat/backgrounds/" + next_name);
				if (!user_image.exists()
						&& (next.toLowerCase().endsWith(".png")
								|| next.toLowerCase().endsWith(".gif")
								|| next.toLowerCase().endsWith(".jpg") || next
								.toLowerCase().endsWith(".jpeg"))) {
					found = true;
				}
			}
		}
		loadUserData();
		/*
		 * If there is no chat window backgound, create one (white background;
		 * file "images/background1.png"; equals to the file "images/ZZZ
		 * white.png").
		 */
		newloc = User.getHome() + "/KemaChat/" + MainUser.background_constant;
		av_file = new File(newloc);
		if (!av_file.exists()) {
			try {
				BufferedImage i = ImageIO.read(new File(
						"images/background1.png"));
				ImageIO.write(i, "PNG", av_file);
			} catch (Exception E) {
				E.printStackTrace();
			}
			MainUser.background = User.getHome()
					+ "/KemaChat/backgrounds/Aqua Computing.PNG";
		}
		/*
		 * Asks and installs the image gallery.
		 */
		File image_done = new File(User.getHome()
				+ "/Library/KemaChat/image_done");
		if (found && !image_done.exists()) {
			if (DialogMessage
					.confirm("Wollen Sie die Bildergallerien installieren (kann einige Sekunden dauern)?<br><br></b>Wenn Sie auf <i>OK</i> klicken, dann steht Ihnen eine kleine Auswahl an Bildern zur<br>Verf&uuml;gung, die als Hintergrundsbild f&uuml;r das Chatfenster verwendet werden k&ouml;nnen.<b>") == 0) {
				setProgressValue(
						3,
						"Installiere Bildergallerie <font size=2>(Dies wird einige Sekunden dauern)</font>...");

				for (int i = 0; i < bg_files.length; i++) {
					String next = bg_files[i].toString();
					String next_name = next.substring(
							next.lastIndexOf("/") + 1, next.length());
					File user_image = new File(User.getHome()
							+ "/KemaChat/backgrounds/" + next_name);
					if (!user_image.exists()
							&& (next.toLowerCase().endsWith(".png")
									|| next.toLowerCase().endsWith(".gif")
									|| next.toLowerCase().endsWith(".jpg") || next
									.toLowerCase().endsWith(".jpeg"))) {
						try {
							String img_name = next_name.substring(0, next_name
									.length() - 4);
							setProgressValue(3,
									"Installiere Bildergallerie <font size=2>(Bild "
											+ img_name + ")</font>...");
							BufferedImage img = ImageIO.read(new File(next));
							if (next.toLowerCase().endsWith(".png")) {
								ImageIO.write(img, "PNG", user_image);
							} else {
								ImageIO.write(img, "JPG", user_image);
							}
						} catch (Exception E) {
							p("Error in Image: number=" + i + "; name=" + next
									+ ";");
							E.printStackTrace();
							DialogMessage
									.error("Fehler bei der Installation der Bildergallerie.<br>Bildergallerie wurde unvollst&auml;ndig oder gar nicht installiert.<br><br>KemaChat wird trotzdem gestartet.");
						}
					}
				}
				KFileManager.writeFile(User.getHome()
						+ "/Library/KemaChat/image_done", "image_done");
			} else {
				if (DialogMessage
						.confirm("Die Bildergallerien werden nicht installiert. Wollen Sie die Bildergallerien beim n&auml;chsten Start von KemaChat installieren?") != 0) {
					KFileManager.writeFile(User.getHome()
							+ "/Library/KemaChat/image_done", "image_done");
				}
			}
		}
		/*
		 * ========================================= Source code description to
		 * be continued... =========================================
		 */
		setProgressValue(10, "Lade Bildergallerie...");

		chooser = new ImageChooser();

		setProgressValue(15, "Lade Userinformationen...");

		setProgressValue(20, "Lade Programminfos...");

		addAppBuilder();

		setProgressValue(23, "Log In...");

		MainUser.logIn();

		setProgressValue(24, "Loading Chat History...");

		HistoryViewer.init();

		avatar = new JLabel("", JLabel.CENTER);

		setProgressValue(25, "Lade Graphikobjekte...");

		font = new JComboBox();
		contactname = new JTextField(35);
		newcontact = new JFrame("Neuer Kontakt hinzuf\u00fcgen");
		pref = new KPreferencesPane(6);
		t_userpath = new JTextField(35);
		main_frame = new JFrame("KemaChat");
		main_toolbar = new JToolBar();
		nickname = new JLabel("");
		contact_list = new JPanel();
		addfirstuser = new JLabel(
				"<html><center><font color=green><br><br><br><b>Es sind noch keine User<br>in der Kontaktliste vorhanden.<br>Hier klicken, um einen User<br>zu hinzuf&uuml;gen.</b></font><center></html>",
				JLabel.CENTER);
		addfirstuser.setCursor(new Cursor(Cursor.HAND_CURSOR));
		addfirstuser.addMouseListener(new MouseAdapter() {
			public void mouseEntered(MouseEvent me) {
				addfirstuser
						.setText("<html><center><u><font color=green><br><br><br><b>Es sind noch keine User<br>in der Kontaktliste vorhanden.<br>Hier klicken, um einen User<br>zu hinzuf&uuml;gen.</b></font></u><center></html>");
			}

			public void mouseExited(MouseEvent me) {
				addfirstuser
						.setText("<html><center><font color=green><br><br><br><b>Es sind noch keine User<br>in der Kontaktliste vorhanden.<br>Hier klicken, um einen User<br>zu hinzuf&uuml;gen.</b></font><center></html>");
			}

			public void mouseClicked(MouseEvent me) {
				addContact();
			}
		});
		c = main_frame.getContentPane();

		info_text = new JLabel("");
		c.add(info_text, BorderLayout.SOUTH);
		scroll_contactlist = new JScrollPane(contact_list);
		window = new Menu("Fenster");
		closewindow = new MenuItem("Fenster schliessen");
		title_online = new JLabel(
				"<html>&nbsp;&nbsp;&nbsp;&nbsp;<b><font size=4 color=navy>Online ("
						+ users_online.length + "):</font></b></html>");
		title_offline = new JLabel(
				"<html>&nbsp;&nbsp;&nbsp;&nbsp;<b><font size=4 color=navy>Offline ("
						+ users_offline.length + "):</font></b></html>");

		setProgressValue(28, "Lade Menus...");

		designs = new JComboBox();

		menubar = new MenuBar();
		showHistory = new MenuItem("Chat-History ansehen");
		contacts = new Menu("Kontakte");
		addnewcontact = new MenuItem("Kontakt hinzuf\u00fcgen...");
		addnewcontact.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ae) {
				addContact();
			}
		});
		HelpViewer.init();
		help = new Menu("Hilfe");
		ask_question = new MenuItem("Frage stellen...");
		addnewcontact.setShortcut(new MenuShortcut((int) 'N', true));
		closewindow.setShortcut(new MenuShortcut((int) 'W', false));
		showHistory.setShortcut(new MenuShortcut((int) 'H', true));
		ask_question.setShortcut(new MenuShortcut((int) '?', false));
		contacts.add(addnewcontact);
		contacts.add(showHistory);
		window.add(closewindow);
		help.add(ask_question);
		menubar.add(contacts);
		menubar.add(help);
		// menubar.add(window);
		main_frame.setMenuBar(menubar);

		showHistory.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ae) {
				HistoryViewer.showHistory("");
			}
		});

		ask_question.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ae) {
				HelpViewer.showHelp();
			}
		});

		setProgressValue(32, "Lade Graphik...");

		main_toolbar.setBorderPainted(false);
		main_toolbar.add(avatar);
		main_toolbar.add(nickname);

		main_frame.setSize(MainUser.mainframe_dimension);
		main_frame.setLocation(MainUser.mainframe_location);
		scroll_contactlist.setBorder(null);
		setProgressValue(34, "Initialisiere Schriftartern...");

		String fonts[] = GraphicsEnvironment.getLocalGraphicsEnvironment()
				.getAvailableFontFamilyNames();

		setProgressValue(35, "Lade Programmversionsdate...");

		KFileManager.writeFile(User.getHome() + "/KemaChat/version",
				app.version);

		setProgressValue(37, "Lade Schriftarten...");

		// <-- LOAD FONTS -->
		for (int i = 0; i < fonts.length; i++) {
			font.addItem("<html><font face=\"" + fonts[i] + "\">" + fonts[i]
					+ "</font></html>");
			if (fonts[i].equals(MainUser.write_font)) {
				font.setSelectedIndex(i);
			}
		}

		setProgressValue(50, "Lade Kontaktlistenlayout...");

		// font.addItem("<html><font face=\"Arial\">Arial</font></html>");
		// if the contacts are sorted, use:
		// contact_list.setLayout( new GridLayout(MainUser.userlist.length+2,
		// 1));
		// if not, use:
		if (MainUser.userlist.length < 30) {
			contact_list.setLayout(new GridLayout(25, 1));
		} else {
			contact_list.setLayout(new GridLayout(MainUser.userlist.length, 1));
		}

		/*
		 * contact_list.add(title_online);
		 * 
		 * for(int i=0;i<users_online.length;i++) { String user_now =
		 * users_online[i]; JLabel next_contact = new JLabel("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<b>"+user_now+"</b></html>");
		 * contact_list.add(next_contact); } contact_list.add(title_offline);
		 * for(int i=0;i<users_offline.length;i++) { String user_now =
		 * users_offline[i]; JLabel next_contact = new JLabel("<html>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<b>"+user_now+"</b></html>");
		 * contact_list.add(next_contact); }
		 */

		setProgressValue(54, "Lade Preferences-Autosave...");

		main_frame.addComponentListener(new ComponentAdapter() {
			public void componentResized(ComponentEvent arg0) {
				MainUser.mainframe_dimension = main_frame.getSize();
				createUserData();
			}

			public void componentMoved(ComponentEvent e) {
				MainUser.mainframe_location = main_frame.getLocation();
				createUserData();
			}
		});
		bgimage = Toolkit.getDefaultToolkit().getImage(
				User.getHome() + "/KemaChat/" + MainUser.background_constant)
				.getScaledInstance(676, 498, Image.SCALE_DEFAULT);
		setProgressValue(56, "Lade Kontaktliste...");

		for (int i = 0; i < MainUser.userlist.length; i++) {
			final ChatUser nextuser_b = new ChatUser(MainUser.userlist[i]);
			final ChatUser nextuser = nextuser_b;
			final String s_nextuser_b = KemaChat.formatText(nextuser
					.getNickName(), nextuser);
			String s_nextuser = s_nextuser_b;

			userwriter[i] = new JLabel("<html><b>" + s_nextuser + "</b></html>");
			contact_list.add(userwriter[i]);
			final int i2 = i;
			final JPopupMenu popup = new JPopupMenu();
			String deleteuserimage_path = new File("images/deleteuser.png")
					.getAbsolutePath();
			String adduserimage_path = new File("images/adduser.png")
					.getAbsolutePath();
			String chatimage_path = new File("images/chat.png")
					.getAbsolutePath();
			JMenuItem chat_user = new JMenuItem("<html><img src=\"file://"
					+ chatimage_path
					+ "\" height=15 width=18> Mit diesem User chatten</html>");
			JMenuItem delete_user = new JMenuItem("<html><img src=\"file://"
					+ deleteuserimage_path + "\" height=18 width=18> User <b>"
					+ nextuser.getName() + "</b> l&ouml;schen</html>");
			JMenuItem add_user = new JMenuItem("<html><img src=\"file://"
					+ adduserimage_path
					+ "\" height=15 width=18> User hinzuf&uuml;gen</html>");
			add_user.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent ae) {
					addContact();
				}
			});
			chat_user.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent ae) {
					chat(nextuser);
				}
			});
			delete_user.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent ae) {
					String e = ae.getActionCommand();
					String theuser = e.substring(e.indexOf("b>") + 2, e
							.indexOf("</b>"));
					deleteUser(theuser);
				}
			});
			popup.add(chat_user);
			popup.add(delete_user);
			popup.add(add_user);
			new Thread(new Runnable() {
				public void run() {
					try {
						while (true) {
							if (popup.isShowing()) {
								for (int i = 0; i < MainUser.userlist.length; i++) {
									userwriter[i].setCursor(new Cursor(
											Cursor.DEFAULT_CURSOR));
								}
								userwriter[i2].setCursor(new Cursor(
										Cursor.DEFAULT_CURSOR));
							} else {
								for (int i = 0; i < MainUser.userlist.length; i++) {
									userwriter[i].setCursor(new Cursor(
											Cursor.HAND_CURSOR));
								}
								userwriter[i2].setCursor(new Cursor(
										Cursor.HAND_CURSOR));
							}
							Thread.sleep(100);
						}
					} catch (Exception E) {

					}
				}
			}).start();

			userwriter[i].addMouseListener(new MouseAdapter() {
				public void mouseReleased(MouseEvent arg0) {
					ChatUser nextuser = nextuser_b;
					if (arg0.isPopupTrigger()) {
						popup.show(userwriter[i2], arg0.getX(), arg0.getY());
					} else {
						if (!popup.isShowing()) {
							chat(nextuser);
						}
					}
				}

				public void mousePressed(MouseEvent me) {

					if (me.isPopupTrigger()) {
						popup.show(userwriter[i2], me.getX(), me.getY());
					}
				}

				public void mouseEntered(MouseEvent arg0) {
					ChatUser nextuser = nextuser_b;
					final String s_nextuser = KemaChat.formatText(nextuser
							.getNickName(), nextuser);
					String additional = "";
					File notexisting = new File("images/warn.png");
					File nochat = new File("images/nochat.png");
					File nolist = new File("images/notinlist.png");
					File hislist = new File(nextuser.getPath()
							+ "/KemaChat/contactlist");
					String hiscontactlist = KFileManager.readFile(hislist
							.toString());
					if (!nextuser.exists()) {
						additional += "<img src=\"file://"
								+ notexisting.getAbsolutePath()
								+ "\" height=12 width=12>";
					} else if (!hislist.exists()) {
						additional += "<img src=\"file://"
								+ nochat.getAbsolutePath()
								+ "\" height=12 width=12>";
					} else if (hiscontactlist.toLowerCase().indexOf(
							User.getName().toLowerCase() + "\n") == -1) {
						additional += "<img src=\"file://"
								+ nolist.getAbsolutePath()
								+ "\" height=12 width=12>";
					}
					if (!nextoffline[i2]) {
						userwriter[i2].setText("<html>&nbsp;&nbsp;&nbsp;&nbsp;"
								+ additional + "<b><u><font color=blue>"
								+ s_nextuser + "</font></u></b></html>");
					} else {
						userwriter[i2].setText("<html>&nbsp;&nbsp;&nbsp;&nbsp;"
								+ additional + "<b><font color=gray><u>"
								+ s_nextuser
								+ " (Offline)</u></font></b></html>");
					}
					isover[i2] = true;
				}

				public void mouseExited(MouseEvent arg0) {
					ChatUser nextuser = nextuser_b;
					final String s_nextuser = KemaChat.formatText(nextuser
							.getNickName(), nextuser);
					String additional = "";
					File notexisting = new File("images/warn.png");
					File nochat = new File("images/nochat.png");
					File nolist = new File("images/notinlist.png");
					File hislist = new File(nextuser.getPath()
							+ "/KemaChat/contactlist");
					String hiscontactlist = KFileManager.readFile(hislist
							.toString());
					if (!nextuser.exists()) {
						additional += "<img src=\"file://"
								+ notexisting.getAbsolutePath()
								+ "\" height=12 width=12>";
					} else if (!hislist.exists()) {
						additional += "<img src=\"file://"
								+ nochat.getAbsolutePath()
								+ "\" height=12 width=12>";
					} else if (hiscontactlist.toLowerCase().indexOf(
							User.getName().toLowerCase() + "\n") == -1) {
						additional += "<img src=\"file://"
								+ nolist.getAbsolutePath()
								+ "\" height=12 width=12>";
					}
					if (!nextoffline[i2]) {
						userwriter[i2].setText("<html>&nbsp;&nbsp;&nbsp;&nbsp;"
								+ additional + "<b>" + s_nextuser
								+ "</b></html>");
					} else {
						userwriter[i2].setText("<html>&nbsp;&nbsp;&nbsp;&nbsp;"
								+ additional + "<b><font color=gray>"
								+ s_nextuser + " (Offline)</font></b></html>");
					}
					isover[i2] = false;
				}
			});
		}

		setProgressValue(70, "Lade Graphikelemente...");

		c.add(main_toolbar, BorderLayout.NORTH);
		c.add(scroll_contactlist);

		setProgressValue(75, "Lade Einstellungen...");

		preparePreferences();

		setProgressValue(95, "Lade \"Kontakt hinzuf&uuml;gen\"-Fenster...");

		prepareAddContact();

		setProgressValue(96, "Lade WindowManager...");

		addWindowManager();

		setProgressValue(97, "Lade Nickname...");

		nickname.setText("<html><b><font size=5>"
				+ formatText(MainUser.nickname) + "</font></b></html>");
		nickname.setCursor(new Cursor(Cursor.HAND_CURSOR));

		nickname.addMouseListener(new MouseAdapter() {
			public void mouseClicked(MouseEvent me) {
				preferences(0);
			}
		});
		avatar.setCursor(new Cursor(Cursor.HAND_CURSOR));
		avatar.addMouseListener(new MouseAdapter() {
			public void mouseClicked(MouseEvent me) {
				preferences(0);
			}
		});

		setProgressValue(98, "Lade Avatar...");

		avatar_file = new File(User.getHome() + "/KemaChat/avatar.jpg");
		String avatar_image = avatar_file.getAbsolutePath();
		scaler = MainUser.avatar_size + 1;
		Icon avatar_icon = new ImageIcon(Toolkit.getDefaultToolkit().getImage(
				avatar_image).getScaledInstance(scaler, scaler,
				Image.SCALE_DEFAULT));
		avatar.setIcon(avatar_icon);
		avatar.setText("");
		if (MainUser.avatar_size == 0) {
			avatar.setVisible(false);
		} else {
			avatar.setVisible(true);
		}

		setProgressValue(100, "Ladevorgang vollendet.");
		loader.setVisible(false);

		if (MainUser.userlist.length == 0) {
			contact_list.add(addfirstuser);
		}

		main_frame.setVisible(true);

		new Thread(new MessageController()).start();
		new Thread(new UserAddController()).start();

	}

	public static void deleteUser(String theuser) {
		if (!confirm("Wollen Sie den User <i>" + theuser
				+ "</i> wirklich l&ouml;schen?", "User l\u00f6schen"))
			return;
		String contacts = KFileManager.readFile(User.getHome()
				+ "/KemaChat/contactlist");
		String exit = "";
		StringTokenizer st = new StringTokenizer(contacts, "\n");
		while (st.hasMoreTokens()) {
			String next = st.nextToken();
			if (!next.equals(theuser)) {
				exit += next + "\n";
			}
		}
		KFileManager.writeFile(User.getHome() + "/KemaChat/contactlist", exit);
		loadUserData();
		repaintList(true);
	}

	public void checkNewUser() {
		File dropbox[] = new File(User.getHome() + "/Public/Drop Box/")
				.listFiles();
		for (int i = 0; i < dropbox.length; i++) {
			File nextfile = dropbox[i];
			String absolutepath = nextfile.toString();
			String filestring = absolutepath.substring(absolutepath
					.lastIndexOf("/") + 1, absolutepath.length());
			String list_now = KUserFileManager.readFile(contactlist_location);
			String username = "";
			if (filestring.startsWith("useradd_")) {
				username = filestring.substring(8, filestring.length());
				nextfile.delete();
			}
			if (filestring.startsWith("useradd_")
					&& list_now.indexOf(username + "\n") == -1) {
				boolean next = confirm(
						"Der User "
								+ username
								+ " hat Sie soeben in seiner Kontaktliste hinzugef&uuml;gt.<br>Wollen Sie ihn ebenfalls in Ihrer Kontaktliste hinzuf&uuml;gen?",
						"KemaChat");
				if (next) {
					contactname.setText(username);
					addContact();
				}

			}

		}
	}

	public static boolean confirm(String msg, String title) {
		int x = DialogMessage.confirm("<html><b>" + msg + "</b></html>", title);
		if (x == 0)
			return true;
		else
			return false;
	}

	public static void refreshPreferencesDesign() {
		designs.setSelectedItem(design);
	}

	public static void preparePreferences() {

		setProgressValue(76, "Lade Einstellungen: Einstellungen...");

		KPreferencesPane.main.setTitle("KemaChat - Einstellungen");
		pref.setLanguage(KPreferencesPane.DEUTSCH);

		KTabbedPane first_pane = pref.getPane();

		setProgressValue(77, "Lade Einstellungen: Account...");
		/*
		 * === START LOADING ACCOUNT ===
		 */
		JPanel first = first_pane.getPanel(0);
		first_pane.setTitleAt(0, "<html><b>Account</b></html>");
		JLabel info_userpath = new JLabel(
				"<html><b>Ordner, indem sich alle User befinden:</b></html>");

		JButton back_userpath = new JButton(
				"<html><b>Zur&uuml;cksetzen</b></html>");
		back_userpath.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ae) {
				t_userpath.setText(MainUser.standard_userdir);
			}
		});
		first.setLayout(new GridLayout(4, 1));
		JPanel first_1 = new JPanel();
		first_1.add(info_userpath);
		first_1.add(t_userpath);
		first_1.add(back_userpath);
		t_userpath.setText(MainUser.userdir);
		JLabel info_nickname = new JLabel("<html><b>Nickname: </b></html>");
		final JTextField t_nickname = new JTextField(20);
		t_nickname.setText(MainUser.nickname);
		JPanel first_2 = new JPanel();
		first_2.add(info_nickname);
		first_2.add(t_nickname);
		JPanel first_3 = new JPanel();
		final JCheckBox allow = new JCheckBox(
				"<html><b>Zulassen dass User, die nicht in meiner Kontaktliste sind, mir Nachrichten schicken k&ouml;nnen.</b></html>");
		JLabel info_avatar = new JLabel("<html><b>Anzeigebild:</b></html>");
		first_3.add(allow);
		if (MainUser.allow == 1) {
			allow.setSelected(true);
		} else {
			allow.setSelected(false);
		}
		/*
		 * font.setSelectedItem(...) makes the load process longer. It's easier
		 * to use font.setSelectedItem(i) when fonts[i] is MainUser.write_font
		 * (in the first part of the load process).
		 */

		/*
		 * END LOADING ACCOUNT
		 */

		setProgressValue(78, "Lade Einstellungen: Avatar...");

		String avatar_image = avatar_file.getAbsolutePath();
		final KButton avatar_button = new KButton("");
		avatar_file = new File(User.getHome() + "/KemaChat/avatar.jpg");
		final int scaler = MainUser.avatar_size + 1;
		Icon avatar_icon = new ImageIcon(Toolkit.getDefaultToolkit().getImage(
				avatar_image).getScaledInstance(scaler, scaler,
				Image.SCALE_DEFAULT));
		avatar.setIcon(avatar_icon);
		avatar.setText("");
		avatar_button.setIcon(avatar_icon);
		avatar_button.setText("");
		if (MainUser.avatar_size == 0) {
			avatar_button.setVisible(false);
		} else {
			avatar_button.setVisible(true);
		}
		avatar_button.addMouseListener(new MouseAdapter() {
			public void mousePressed(MouseEvent me) {
				avatar_button.press();
			}

			public void mouseReleased(MouseEvent me) {
				avatar_file = new File(User.getHome() + "/KemaChat/avatar.jpg");
				avatar_button.release();
				JFileChooser file_chooser = new JFileChooser();
				javax.swing.filechooser.FileFilter filter = new javax.swing.filechooser.FileFilter() {
					public boolean accept(File pathname) {
						String filename = pathname.toString().toLowerCase();
						return filename.endsWith(".jpg")
								|| filename.endsWith(".jpeg")
								|| filename.endsWith(".png")
								|| filename.endsWith(".gif")
								|| pathname.isDirectory();
					}

					public String getDescription() {
						return "Bilddateien (*.JPG, *.JPEG, *.PNG, *.GIF)";
					}
				};
				file_chooser.setFileFilter(filter);
				file_chooser.setSelectedFile(new File(User.getHome()
						+ "/Pictures/"));
				file_chooser.showOpenDialog(null);
				File new_file = file_chooser.getSelectedFile();
				if (new_file == null) {
					return;
				}
				if (new_file.isDirectory()) {
					return;
				}
				avatar_file = new_file;
				String filename = avatar_file.toString().toLowerCase();
				if (!filename.toLowerCase().endsWith(".png")
						&& !filename.toLowerCase().endsWith(".jpg")
						&& !filename.toLowerCase().endsWith(".jpeg")
						&& !filename.toLowerCase().endsWith(".gif")) {
					DialogMessage
							.error("Die ausgew&auml;hlte Datei ist keine g&uuml;ltige Bilddatei.");
					return;
				}

				try {
					filename = avatar_file.toString().toLowerCase();
					BufferedImage i = ImageIO.read(new File(avatar_file
							.toString()));
					String newloc = User.getHome() + "/KemaChat/avatar.jpg";
					if (filename.endsWith(".png")) {
						ImageIO.write(i, "PNG", new File(newloc));
					} else {
						ImageIO.write(i, "JPG", new File(newloc));
					}
				} catch (Exception E) {
				}
				avatar_file = new File(User.getHome() + "/KemaChat/avatar.jpg");
				int scaler2 = scaler + 1;
				try {
					Icon avatar_icon = new ImageIcon(ImageIO.read(avatar_file)
							.getScaledInstance(scaler2, scaler2,
									Image.SCALE_DEFAULT));
					avatar.setIcon(avatar_icon);
					avatar.setText("");
					avatar_button.setIcon(avatar_icon);
				} catch (Exception E) {
					E.printStackTrace();
				}
				if (MainUser.avatar_size == 0) {
					avatar_button.setVisible(false);
					avatar.setVisible(false);
				} else {
					avatar_button.setVisible(true);
					avatar.setVisible(true);
				}
			}

		});

		setProgressValue(81, "Lade Einstellungen: Avatargr&ouml;sse...");

		final JSlider avatar_slider = new JSlider(0, 150);
		avatar_slider.setMajorTickSpacing(30);
		avatar_slider.setPaintTicks(true);
		avatar_slider.setPaintLabels(true);
		avatar_slider.setValue(MainUser.avatar_size);
		avatar_slider.addChangeListener(new ChangeListener() {
			public void stateChanged(ChangeEvent arg0) {
				int value = avatar_slider.getValue();
				MainUser.avatar_size = value;
				avatar_file = new File(User.getHome() + "/KemaChat/avatar.jpg");
				if (value == 0) {
					avatar_button.setText("");
					avatar_button.setVisible(false);
				} else {
					avatar_file = new File(User.getHome()
							+ "/KemaChat/avatar.jpg");
					int scaler2 = MainUser.avatar_size + 1;
					try {
						Icon avatar_icon = new ImageIcon(ImageIO.read(
								avatar_file).getScaledInstance(scaler2,
								scaler2, Image.SCALE_DEFAULT));
						avatar.setIcon(avatar_icon);
						avatar.setText("");
						avatar_button.setIcon(avatar_icon);
					} catch (Exception E) {
						E.printStackTrace();
					}
					avatar_button.setText("");
					avatar_button.setVisible(true);
					if (MainUser.avatar_size == 0) {
						avatar.setVisible(false);
					} else {
						avatar.setVisible(true);
					}
				}
			}
		});

		setProgressValue(84, "Lade Einstellungen: Graphikelemente (Account)...");

		avatar_button.setCursor(new Cursor(Cursor.HAND_CURSOR));
		JPanel first_4 = new JPanel();
		first_4.add(info_avatar);
		first_4.add(avatar_button);
		first_4.add(avatar_slider);

		first.add(first_1);
		first.add(first_2);
		first.add(first_3);
		first.add(first_4);

		setProgressValue(85, "Lade Einstellungen: Schriftart und Farbe...");

		JPanel second = first_pane.getPanel(1);
		second.setLayout(new GridLayout(4, 1));
		JPanel second_1 = new JPanel();
		first_pane.setTitleAt(1, "<html><b>Schriftart und Farbe</b></html>");

		JLabel info_font = new JLabel("<html><b>Schriftart:</b></html>");
		final JLabel info_color = new JLabel(
				"<html><b>&nbsp;&nbsp;&nbsp;Farbe:</b></html>");
		final KButton color = new KButton("<html><font face=\""
				+ MainUser.write_font
				+ "\" style=\"font-size:16pt\">Ein Text</html>");
		thecolor = new Color(MainUser.write_color1, MainUser.write_color2,
				MainUser.write_color3);
		color.setBackground(thecolor);
		color.setForeground(thecolor);

		setProgressValue(86, "Lade Einstellungen: Farbe...");

		color.addMouseListener(new MouseAdapter() {
			public void mousePressed(MouseEvent me) {
				color.press();
			}

			public void mouseReleased(MouseEvent me) {
				Color oldcolor = thecolor;
				color.release();
				thecolor = JColorChooser.showDialog(null,
						"Farbe ausw\u00e4hlen", thecolor);
				if (thecolor == null) {
					thecolor = oldcolor;
				}
				color.setBackground(thecolor);
				color.setForeground(thecolor);
			}
		});

		setProgressValue(87, "Lade Einstellungen: Textstil...");

		final JCheckBox bold = new JCheckBox("<html><b>Fett</b></html>");
		final JCheckBox italic = new JCheckBox("<html><i>Kursiv</i></html>");
		final JCheckBox underline = new JCheckBox(
				"<html><u>Unterstrichen</u></html>");

		if (MainUser.write_bold == 1) {
			bold.setSelected(true);
		} else {
			bold.setSelected(false);
		}
		if (MainUser.write_italic == 1) {
			italic.setSelected(true);
		} else {
			italic.setSelected(false);
		}
		if (MainUser.write_underline == 1) {
			underline.setSelected(true);
		} else {
			underline.setSelected(false);
		}

		setProgressValue(88, "Lade Einstellungen: Textstil...");
		ItemListener l_style = new ItemListener() {
			public void itemStateChanged(ItemEvent ie) {
				int thestyle = 0;
				if (bold.isSelected()) {
					thestyle++;
				}
				if (italic.isSelected()) {
					thestyle += 2;
				}
				String thefont = font.getSelectedItem().toString();
				thefont = thefont.substring(thefont.lastIndexOf("\"") + 2,
						thefont.indexOf("</font>"));
				color.setFont(new Font(thefont, thestyle, 16));
				if (underline.isSelected()) {
					color
							.setText("<html><u><font face=\""
									+ thefont
									+ "\" style=\"font-size:16pt\">Ein Text</u></html>");
				} else {
					color.setText("<html><font face=\"" + thefont
							+ "\" style=\"font-size:16pt\">Ein Text</html>");
				}
			}
		};
		setProgressValue(89, "Lade Einstellungen: Textstil...");

		bold.addItemListener(l_style);
		italic.addItemListener(l_style);
		underline.addItemListener(l_style);

		int thestyle = 0;
		if (bold.isSelected()) {
			thestyle++;
		}
		if (italic.isSelected()) {
			thestyle += 2;
		}

		setProgressValue(90, "Lade Einstellungen: Schriftarten...");

		String thefont = font.getSelectedItem().toString();
		thefont = thefont.substring(thefont.lastIndexOf("\"") + 2, thefont
				.indexOf("</font>"));
		color.setFont(new Font(thefont, thestyle, 16));
		if (underline.isSelected()) {
			color.setText("<html><u><font face=\"" + thefont
					+ "\" style=\"font-size:16pt\">Ein Text</u></html>");
		} else {
			color.setText("<html><font face=\"" + thefont
					+ "\" style=\"font-size:16pt\">Ein Text</html>");
		}

		font.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent ie) {
				String thefont = font.getSelectedItem().toString();
				thefont = thefont.substring(thefont.lastIndexOf("\"") + 2,
						thefont.indexOf("</font>"));
				color.setText("<html><b><font face=\"" + thefont
						+ "\" style=\"font-size:16pt\">Ein Text</b></html>");
			}
		});

		setProgressValue(91, "Lade Einstellungen: Graphikelemente...");

		JLabel info_added_text = new JLabel(
				"<html><b>Schriftfarbe von Informationstexten in den Unterhaltungen (z.B. hans_muster sagt...):</b></html>");
		final JRadioButton ad_black = new JRadioButton("Schwarz");
		final JRadioButton ad_darkgray = new JRadioButton("Dunkelgrau");
		final JRadioButton ad_gray = new JRadioButton("Grau");
		final JRadioButton ad_lightgray = new JRadioButton("Hellgrau");
		final JRadioButton ad_white = new JRadioButton("Weiss");
		final JRadioButton ad_mediumgray = new JRadioButton("Standard");
		ad_black.setForeground(Color.BLACK);
		ad_darkgray.setForeground(Color.DARK_GRAY);
		ad_gray.setForeground(Color.GRAY);
		ad_lightgray.setForeground(Color.LIGHT_GRAY.darker());
		ad_white.setForeground(Color.WHITE);
		ad_mediumgray.setForeground(new Color(123, 123, 123));
		ButtonGroup ad_bg = new ButtonGroup();
		ad_bg.add(ad_black);
		ad_bg.add(ad_darkgray);
		ad_bg.add(ad_gray);
		ad_bg.add(ad_lightgray);
		ad_bg.add(ad_white);
		ad_bg.add(ad_mediumgray);

		second_1.add(info_font);
		second_1.add(font);
		JPanel second_2 = new JPanel();
		second_2.add(info_color);
		second_2.add(color);
		JPanel second_3 = new JPanel();
		second_3.add(bold);
		second_3.add(italic);
		second_3.add(underline);
		JPanel second_4 = new JPanel();
		second_4.add(info_added_text);
		second_4.add(ad_black);
		second_4.add(ad_darkgray);
		second_4.add(ad_gray);
		second_4.add(ad_lightgray);
		second_4.add(ad_white);
		second_4.add(ad_mediumgray);
		second.add(second_1);
		second.add(second_2);
		second.add(second_3);
		second.add(second_4);
		if (MainUser.ad_color == 0)
			ad_black.setSelected(true);
		else if (MainUser.ad_color == 1)
			ad_darkgray.setSelected(true);
		else if (MainUser.ad_color == 2)
			ad_gray.setSelected(true);
		else if (MainUser.ad_color == 3)
			ad_lightgray.setSelected(true);
		else if (MainUser.ad_color == 4)
			ad_white.setSelected(true);
		else if (MainUser.ad_color == 5)
			ad_mediumgray.setSelected(true);

		setProgressValue(92, "Lade Einstellungen: Design...");

		JPanel third = first_pane.getPanel(2);
		first_pane.setTitleAt(2, "<html><b>Design</b></html>");

		JPanel intern = new JPanel();
		intern.setLayout(new GridLayout(4, 1));
		JPanel intern1 = new JPanel();
		JPanel intern2 = new JPanel();
		JPanel intern3 = new JPanel();
		JPanel intern4 = new JPanel();
		final JRadioButton radio_standard = new JRadioButton("Standard Design");
		final JRadioButton radio_other = new JRadioButton("Anderes Design");
		final JLabel info_design = new JLabel(
				"<html>Ausgew&auml;hltes Design: <b>" + design + "</b></html>");
		ButtonGroup design_bg = new ButtonGroup();
		final JLabel warning_design = new JLabel(
				"<html><i>Hinweis: Sie m&uuml;ssen KemaChat neustarten, um das ausgew&auml;hlte<br>Design zu verwenden.</i></html>");
		design_bg.add(radio_standard);
		design_bg.add(radio_other);
		for (int i = 0; i < themes.length; i++) {
			designs.addItem(themes[i]);
			if (themes[i].equals(design)) {
				designs.setSelectedIndex(i);
			}
		}
		final JButton choose_design = new JButton(
				"<html>Design ausw&auml;hlen...</html>");
		ActionListener al_design = new ActionListener() {
			public void actionPerformed(ActionEvent ae) {
				radio_standard.setSelected(false);
				radio_other.setSelected(true);
				JFileChooser chooser = new JFileChooser();
				chooser.showOpenDialog(null);
				File selected = chooser.getSelectedFile();
				if (selected == null || !selected.exists()
						|| selected.equals("null")) {
					radio_standard.setSelected(true);
					radio_other.setSelected(false);
					return;
				}

				String design_name = selected.toString();
				design_name = design_name.substring(design_name
						.lastIndexOf("/") + 1, design_name.length());
				if (!design_name.endsWith(".kthm")) {
					DialogMessage
							.error("<html><font color=red><b>Die ausgew&auml;hlte Datei ist keine Design-Datei (Design-Dateien enden mit <i>.kthm</i>)!</b></font></html>");
					radio_standard.setSelected(true);
					radio_other.setSelected(false);
					return;
				}
				info_design.setText("<html>Design wird geladen...</html>");
				try {
					Runtime run = Runtime.getRuntime();
					run.exec("cp " + selected + " " + User.getHome()
							+ "/KemaChat/theme.kthm");
				} catch (Exception E) {

				}
				design = design_name;
				info_design.setText("<html>Ausgew&auml;hltes Design: <b>"
						+ design + "</b></html>");
			}
		};

		ActionListener resetDefault = new ActionListener() {
			public void actionPerformed(ActionEvent ae) {
				design = designs.getSelectedItem().toString();
				info_design.setText("<html>Ausgew&auml;hltes Design: <b>"
						+ design + "</b></html>");
			}
		};

		choose_design.addActionListener(al_design);
		radio_other.addActionListener(al_design);
		radio_standard.addActionListener(resetDefault);

		if (design.endsWith(".kthm")) {
			radio_other.setSelected(true);
			radio_standard.setSelected(false);
		} else {
			radio_standard.setSelected(true);
			radio_other.setSelected(false);
		}

		intern1.add(info_design);

		intern2.add(radio_standard);
		intern2.add(designs);

		intern3.add(radio_other);
		intern3.add(choose_design);

		intern4.add(warning_design);

		intern.add(intern1);
		intern.add(intern2);
		intern.add(intern3);
		intern.add(intern4);
		third.add(intern);

		JPanel four = first_pane.getPanel(3);
		first_pane.setTitleAt(3, "<html><b>History</b></html>");
		final JCheckBox save_history = new JCheckBox(
				"<html><b>Gespr&auml;che speichern</b></html>");
		save_history.setSelected(MainUser.save_history);
		JButton show_history = new JButton(
				"<html><b>History anschauen</b></html>");
		four.add(save_history);
		four.add(show_history);
		show_history.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ae) {
				HistoryViewer.showHistory("");
			}
		});
		final JButton delete_history = new JButton(
				"<html><b>History l&ouml;schen</b></html>");
		four.add(delete_history);
		delete_history.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ae) {
				if (DialogMessage
						.warning_confirm("Sind Sie sicher, dass Sie die History l&ouml;schen wollen? Alle gespeicherten Gespr&auml;che gehen verloren.") == 0) {
					HistoryViewer.delete();
					DialogMessage
							.message("Die History wurde erfolgreich gel&ouml;scht.");
				}
			}
		});

		JPanel five = first_pane.getPanel(4);
		five.setLayout(new BorderLayout());
		first_pane.setTitleAt(4, "<html><b>Hintergrund</b></html>");
		JLabel info_background = new JLabel(
				"<html><center><b><font size=5 color=navy>Hintergrundsbild in Chatfenstern</font></b></center></html>",
				JLabel.CENTER);
		five.add(info_background, BorderLayout.NORTH);

		JButton choose_image = new JButton("<html>Bild &auml;ndern</html>");

		bgimage_panel = new JLabel();

		File background_file = new File(User.getHome() + "/KemaChat/"
				+ MainUser.background_constant);
		if (!background_file.exists()) {
			try {
				BufferedImage i = ImageIO.read(new File(
						"images/background1.png"));
				ImageIO.write(i, "PNG", new File(User.getHome() + "/KemaChat/"
						+ MainUser.background_constant));
			} catch (Exception E) {
				E.printStackTrace();
				DialogMessage
						.error("Ein Fehler ist aufgetreten.<br><br>Entweder:<br>1. Das Application Bundle ist fehlerhaft. Datei images/background1.png wurde nicht gefunden!<br>Oder:<br>2. Der Ordner KemaChat in user-home existiert nicht!<br>Oder:<br>3. Unbekannter Fehler beim schreiben des Bildes.");
			}
		}

		try {
			avatar_icon = new ImageIcon(ImageIO.read(
					new File(User.getHome() + "/KemaChat/"
							+ MainUser.background_constant)).getScaledInstance(
					676, 498, Image.SCALE_DEFAULT));
			KemaChat.bgimage_panel.setIcon(avatar_icon);
			KemaChat.bgimage_panel.setText("");
		} catch (Exception E) {
			E.printStackTrace();
		}
		bgimage_panel.setBorder(BorderFactory.createRaisedBevelBorder());
		five.add(bgimage_panel);
		five.add(choose_image, BorderLayout.SOUTH);
		choose_image.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ae) {
				chooser.visible();
			}
		});

		JPanel six = first_pane.getPanel(5);
		six.setLayout(new GridLayout(6, 1));
		first_pane.setTitleAt(5,
				"<html><b>T&ouml;ne und Kl&auml;nge</b></html>");
		JPanel six_1 = new JPanel();
		six_1.setLayout(new GridLayout(1, 3));
		final JCheckBox c_sound_login = new JCheckBox(
				"<html><b>Klang wenn ein User online geht</b></html>");
		final DefaultListModel m_sound_login = new DefaultListModel();
		final JList l_sound_login = new JList(m_sound_login);
		final JButton b_sound_login = new JButton("<html><b>Play</b></html>");
		l_sound_login.setBorder(BorderFactory.createLoweredBevelBorder());
		JPanel sound_internal_1 = new JPanel();
		sound_internal_1.add(b_sound_login);
		six_1.add(c_sound_login);
		six_1.add(new JScrollPane(l_sound_login));
		six_1.add(sound_internal_1);
		six.add(six_1);

		JPanel six_2 = new JPanel();
		six_2.setLayout(new GridLayout(1, 3));
		final JCheckBox c_sound_newmessage = new JCheckBox(
				"<html><b>Klang bei einer neuen Nachricht</b></html>");
		final DefaultListModel m_sound_newmessage = new DefaultListModel();
		final JList l_sound_newmessage = new JList(m_sound_newmessage);
		l_sound_newmessage.setBorder(BorderFactory.createLoweredBevelBorder());
		final JButton b_sound_newmessage = new JButton(
				"<html><b>Play</b></html>");
		JPanel sound_internal_2 = new JPanel();
		sound_internal_2.add(b_sound_newmessage);
		six_2.add(c_sound_newmessage);
		six_2.add(new JScrollPane(l_sound_newmessage));
		six_2.add(sound_internal_2);
		six.add(six_2);

		JPanel six_3 = new JPanel();
		six_3.setLayout(new GridLayout(1, 3));
		final JCheckBox c_sound_logout = new JCheckBox(
				"<html><b>Klang wenn ein User offline geht</b></html>");
		final DefaultListModel m_sound_logout = new DefaultListModel();
		final JList l_sound_logout = new JList(m_sound_logout);
		l_sound_logout.setBorder(BorderFactory.createLoweredBevelBorder());
		final JButton b_sound_logout = new JButton("<html><b>Play</b></html>");
		JPanel sound_internal_3 = new JPanel();
		sound_internal_3.add(b_sound_logout);
		six_3.add(c_sound_logout);
		six_3.add(new JScrollPane(l_sound_logout));
		six_3.add(sound_internal_3);
		six.add(six_3);

		c_sound_login.setSelected(MainUser.sound_play_login);
		c_sound_newmessage.setSelected(MainUser.sound_play_newmessage);
		c_sound_logout.setSelected(MainUser.sound_play_logout);

		File sounds[] = new File("sounds").listFiles();
		for (int i = 0; i < sounds.length; i++) {
			String next_file = sounds[i].toString();
			next_file = next_file.substring(next_file.lastIndexOf("/") + 1,
					next_file.length());
			next_file = next_file.replaceAll("\n", "");
			if (next_file.toLowerCase().endsWith(".aif")
					|| next_file.toLowerCase().endsWith(".aiff")) {
				if (next_file.toLowerCase().endsWith(".aif")) {
					next_file = next_file.substring(0, next_file.length() - 4);
				} else if (next_file.toLowerCase().endsWith(".aiff")) {
					next_file = next_file.substring(0, next_file.length() - 5);
				}
				m_sound_login.addElement(next_file);
				m_sound_newmessage.addElement(next_file);
				m_sound_logout.addElement(next_file);
			}
		}

		l_sound_login.setSelectedValue(MainUser.sound_login, true);
		l_sound_newmessage.setSelectedValue(MainUser.sound_newmessage, true);
		l_sound_logout.setSelectedValue(MainUser.sound_logout, true);

		b_sound_login.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ae) {
				Sound play_sound = new Sound("sounds/"
						+ l_sound_login.getSelectedValue().toString() + ".aif");
				play_sound.play();
			}
		});

		b_sound_newmessage.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ae) {
				Sound play_sound = new Sound("sounds/"
						+ l_sound_newmessage.getSelectedValue().toString()
						+ ".aif");
				play_sound.play();
			}
		});

		b_sound_logout.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ae) {
				Sound play_sound = new Sound("sounds/"
						+ l_sound_logout.getSelectedValue().toString() + ".aif");
				play_sound.play();
			}
		});

		ButtonGroup bg_sound = new ButtonGroup();
		final JRadioButton r_always_newmessage = new JRadioButton(
				"<html><b>Bei einer neuen Nachricht immer einen Klang abspielen</b></html>");
		final JRadioButton r_sometimes_newmessage = new JRadioButton(
				"<html><b>Bei einer neuen Nachricht Klang abspielen wenn das Chatfenster nicht im Vordergrund liegt</b></html>");
		bg_sound.add(r_always_newmessage);
		bg_sound.add(r_sometimes_newmessage);
		JPanel empty_panel = new JPanel();
		six.add(empty_panel);
		JPanel sub_sound = new JPanel();
		sub_sound.add(r_always_newmessage);
		sub_sound.add(r_sometimes_newmessage);
		six.add(sub_sound);
		if (MainUser.sound_always_newmessage) {
			r_always_newmessage.setSelected(true);
			r_sometimes_newmessage.setSelected(false);
		} else {
			r_always_newmessage.setSelected(false);
			r_sometimes_newmessage.setSelected(true);
		}

		final class PreferencesManager {
			public void save() {

				/*
				 * START PREFERENCES SAVE BLOCK
				 */

				// DESIGN:
				if (radio_standard.isSelected()) {
					design = designs.getSelectedItem().toString();
				}
				KFileManager.writeFile(User.getHome() + "/KemaChat/design",
						design);
				updateDesign();

				// Others:

				MainUser.userdir = t_userpath.getText();
				MainUser.nickname = t_nickname.getText();
				if (MainUser.nickname.equals(""))
					MainUser.nickname = User.getName();
				String thefont = font.getSelectedItem().toString();
				thefont = thefont.substring(thefont.lastIndexOf("\"") + 2,
						thefont.indexOf("</font>"));
				MainUser.write_color1 = color.getForeground().getRed();
				MainUser.write_color2 = color.getForeground().getGreen();
				MainUser.write_color3 = color.getForeground().getBlue();
				MainUser.avatar_size = avatar_slider.getValue();
				nickname.setText("<html><b><font size=5>"
						+ formatText(MainUser.nickname) + "</font></b></html>");
				MainUser.write_font = thefont;
				if (MainUser.avatar_size == 0) {
					avatar.setVisible(false);
				} else {
					avatar.setVisible(true);
				}

				if (bold.isSelected()) {
					MainUser.write_bold = 1;
				} else {
					MainUser.write_bold = 0;
				}
				if (italic.isSelected()) {
					MainUser.write_italic = 1;
				} else {
					MainUser.write_italic = 0;
				}
				if (underline.isSelected()) {
					MainUser.write_underline = 1;
				} else {
					MainUser.write_underline = 0;
				}
				if (allow.isSelected()) {
					MainUser.allow = 1;
				} else {
					MainUser.allow = 0;
				}
				font.setSelectedItem("<html><font face=\""
						+ MainUser.write_font + "\">" + MainUser.write_font
						+ "</font></html>");
				color.setText("<html><b><font face=\"" + MainUser.write_font
						+ "\" style=\"font-size:16pt\">Ein Text</b></html>");
				int thestyle = 0;
				if (bold.isSelected()) {
					thestyle++;
				}
				if (italic.isSelected()) {
					thestyle += 2;
				}
				color.setFont(new Font(thefont, thestyle, 16));
				if (underline.isSelected()) {
					color
							.setText("<html><u><font face=\""
									+ thefont
									+ "\" style=\"font-size:16pt\">Ein Text</u></html>");
				} else {
					color.setText("<html><font face=\"" + thefont
							+ "\" style=\"font-size:16pt\">Ein Text</html>");
				}
				MainUser.save_history = save_history.isSelected();
				if (ad_black.isSelected()) {
					MainUser.ad_color = 0;
				} else if (ad_darkgray.isSelected()) {
					MainUser.ad_color = 1;
				} else if (ad_gray.isSelected()) {
					MainUser.ad_color = 2;
				} else if (ad_lightgray.isSelected()) {
					MainUser.ad_color = 3;
				} else if (ad_white.isSelected()) {
					MainUser.ad_color = 4;
				} else if (ad_mediumgray.isSelected()) {
					MainUser.ad_color = 5;
				}
				MainUser.sound_login = l_sound_login.getSelectedValue()
						.toString();
				MainUser.sound_newmessage = l_sound_newmessage
						.getSelectedValue().toString();
				MainUser.sound_logout = l_sound_logout.getSelectedValue()
						.toString();
				MainUser.sound_always_newmessage = r_always_newmessage
						.isSelected();
				MainUser.sound_play_login = c_sound_login.isSelected();
				MainUser.sound_play_newmessage = c_sound_newmessage
						.isSelected();
				MainUser.sound_play_logout = c_sound_logout.isSelected();
				createUserData();
				KPreferencesPane.main.setVisible(false);
				/*
				 * END PREFERENCES SAVE BLOCK
				 */
			}
		}
		KPreferencesPane.main.addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent we) {
				new PreferencesManager().save();
			}
		});
		setProgressValue(93, "Lade Einstellungen: Speichern...");
		pref.getButton().addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ae) {
				new PreferencesManager().save();
			}
		});
		setProgressValue(94, "Lade Einstellungen...");
	}

	public void addWindowManager() {
		main_frame.addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent arg0) {
				quit();
			}
		});
	}

	public void addMenuBar(JFrame frame) {
		frame.setMenuBar(menubar);
	}

	public void addAppBuilder() {
		Application app2 = Application.getApplication();
		app2.addAboutMenuItem();
		app2.addPreferencesMenuItem();
		app2.setEnabledAboutMenu(true);
		app2.setEnabledPreferencesMenu(true);
		ApplicationListener appl = new ApplicationListener() {

			public void handleAbout(ApplicationEvent arg0) {
				final JFrame about = new JFrame("\u00dcber KemaChat");
				about.setLocation(400, 300);
				about.setSize(300, 200);
				about.setResizable(false);
				JButton ok = new JButton("<html><b>OK</b></html>");
				JLabel info = new JLabel(
						"<html><center><b><font color=green size=5>KemaChat "
								+ app.version
								+ "</font><br><br><br>Freigegeben am "
								+ app.release_date
								+ ".<br>Copyright &copy; 2006 Matteo Pagamici.<br>All rights reserved.</b></center></html>",
						JLabel.CENTER);

				about.getContentPane().add(info);
				about.getContentPane().add(ok, BorderLayout.SOUTH);

				addWindowCloseButtonEvent(ok, about);

				about.setVisible(true);
			}

			public void handleOpenApplication(ApplicationEvent arg0) {

			}

			public void handleOpenFile(ApplicationEvent arg0) {

			}

			public void handlePreferences(ApplicationEvent arg0) {
				preferences(pref_index);
			}

			public void handlePrintFile(ApplicationEvent arg0) {

			}

			public void handleQuit(ApplicationEvent arg0) {
				quit();
			}

			public void handleReOpenApplication(ApplicationEvent arg0) {

			}
		};
		app2.addApplicationListener(appl);
	}

	public static void sendMessage(String message, ChatUser user) {
		String userpath = user.getPath();
		if (!user.isOnline()) {
			return;
		}
		for (int i = 0; i < 100; i++) {
			File next = new File(userpath + "/Public/Drop Box/message_"
					+ User.getName() + "_" + i);
			if (!next.exists()) {
				KFileManager.writeFile(next.toString(), message);
				break;
			}
		}
	}

	public static void chat(ChatUser user) {
		if (chatWith.indexOf(user.getName() + " ") != -1) {
			focusto = user.getName();
			return;
		}
		if (!user.exists()) {
			error("Der User </font><font color=black>" + user.getName()
					+ "</font><font color=red> konnte nicht gefunden werden.");
			return;
		}
		chat_windows[window_count] = new ChatWindow(user);
		chatWith += "" + user.getName() + " ";
		chat_windows[window_count].init();
		chat_windows[window_count].start();
		window_count++;
		chatnumber++;
	}

	public void quit() {
		inputUserData();
		createUserData();
		MainUser.logOut();
		File toDelete = new File(User.getHome() + "/KemaChat/online");
		toDelete.delete();
		if (toDelete.exists()) {
			error("<big>KemaChat Debugger</big><br><br>Ein Fehler ist aufgetreten. Die Datei <i>online</i> konnte nicht gel&ouml;scht werden. Log Out fehlgeschlagen.");
			p("Could not delete the online-file:\n\t"
					+ toDelete.toString()
					+ "\nUser will remain with status online. Exit with status 1 (Error).");
			System.exit(1);
		}
		System.exit(0);
	}

	public void complete() {
		ListPainter lp = new ListPainter();
		Thread T_lp = new Thread(lp);
		T_lp.start();
		p("Loading completed.");
	}

	public static void p(String x) {
		System.out.println("KEMACHAT DEBUG MODE - " + x);
	}

	public static void main(String[] args) {
		p("Start loading...");
		KemaChat kemachat = new KemaChat();
		p("Completing...");
		kemachat.complete();
	}

	public void repaintFrame() {
		main_frame.setVisible(false);
		KemaChat kemachat = new KemaChat();
		kemachat.complete();
	}

	public void prepareAddContact() {
		newcontact.setSize(500, 120);
		newcontact.setLocation(400, 300);

		final JLabel info = new JLabel(
				"<html><b>Geben Sie hier den Accountnamen (vorname_name) des Kontakts ein:</b></html>");
		final JButton ok = new JButton("<html><b>OK</b></html>");
		final JButton cancel = new JButton("<html><b>Abbrechen</b></html>");
		newcontact.getContentPane().setLayout(new FlowLayout());
		newcontact.getContentPane().add(info);
		newcontact.getContentPane().add(contactname);
		newcontact.getContentPane().add(cancel);
		newcontact.getContentPane().add(ok);

		contactname.addKeyListener(new KeyAdapter() {
			public void keyReleased(KeyEvent ke) {
				if (ke.getKeyChar() == '\n'
						&& !contactname.getText().equals("")) {
					String username = contactname.getText();
					createNewContact(username);
					contactname.setText("");

				} else if (ke.getKeyCode() == KeyEvent.VK_ESCAPE) {
					newcontact.setVisible(false);
				}
			}
		});

		addWindowCloseButtonEvent(cancel, newcontact);
		ok.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ae) {
				String username = contactname.getText();
				createNewContact(username);
			}
		});

		newcontact.setResizable(false);
	}

	public boolean createNewContact(String username) {
		if (username.equals("")) {
			return false;
		}
		if (username.startsWith(".") || username.startsWith("/")) {
			error("Bitte geben Sie einen g&uuml;ltigen Username ein.");
			return false;
		}
		if (username.toLowerCase().equals(User.getName().toLowerCase())
				&& !MainUser.allow_self) {
			error("Sie k&ouml;nnen sich nicht selber zur Kontaktliste hinzuf&uuml;gen.");
			return false;
		}
		ChatUser user_now = new ChatUser(username);
		String list_now = KUserFileManager.readFile(contactlist_location);
		if (!user_now.exists()) {
			error("Der User </font><font color=black>" + username
					+ "</font><font color=red> existiert nicht.");
			return false;
		} else if (list_now.toLowerCase()
				.indexOf("\n" + username.toLowerCase()) != -1) {
			error("Der User </font><font color=black>"
					+ username
					+ "</font><font color=red> ist in Ihrer Kontaktliste schon vorhanden.");
			return false;
		} else {
			MainUser.addContact(username);
			contactname.setText("");
			newcontact.setVisible(false);
			repaintList(true);
			return true;
		}
	}

	public static void addContact() {
		newcontact.requestFocus();
		newcontact.setVisible(true);
	}

	public static void repaintList(boolean mustRemove) {
		if (mustRemove) {
			contact_list.removeAll();
			main_frame.setVisible(false);
		}
		loadUserData();
		String contactlist = KFileManager.readFile(User.getHome()
				+ "/KemaChat/contactlist");
		StringTokenizer st = new StringTokenizer(contactlist, "\n");
		int count = 0;
		MainUser.userlist = new String[st.countTokens()];
		while (st.hasMoreTokens()) {
			String next = st.nextToken();
			MainUser.userlist[count] = next;
			count++;
		}
		for (int i = 0; i < MainUser.userlist.length; i++) {
			final ChatUser nextuser_b = new ChatUser(MainUser.userlist[i]);
			final ChatUser nextuser = nextuser_b;
			final String s_nextuser_b = KemaChat.formatText(nextuser
					.getNickName(), nextuser);
			String s_nextuser = s_nextuser_b;

			userwriter[i] = new JLabel("<html><b>" + s_nextuser + "</b></html>");
			if (mustRemove)
				contact_list.add(userwriter[i]);
			final int i2 = i;
			final JPopupMenu popup = new JPopupMenu();
			String deleteuserimage_path = new File("images/deleteuser.png")
					.getAbsolutePath();
			String adduserimage_path = new File("images/adduser.png")
					.getAbsolutePath();
			String chatimage_path = new File("images/chat.png")
					.getAbsolutePath();
			JMenuItem chat_user = new JMenuItem("<html><img src=\"file://"
					+ chatimage_path
					+ "\" height=15 width=18> Mit diesem User chatten</html>");
			JMenuItem delete_user = new JMenuItem("<html><img src=\"file://"
					+ deleteuserimage_path + "\" height=18 width=18> User <b>"
					+ nextuser.getName() + "</b> l&ouml;schen</html>");
			JMenuItem add_user = new JMenuItem("<html><img src=\"file://"
					+ adduserimage_path
					+ "\" height=15 width=18> User hinzuf&uuml;gen</html>");
			add_user.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent ae) {
					addContact();
				}
			});
			chat_user.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent ae) {
					chat(nextuser);
				}
			});
			delete_user.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent ae) {
					String e = ae.getActionCommand();
					String theuser = e.substring(e.indexOf("b>") + 2, e
							.indexOf("</b>"));
					p(theuser);
					if (!confirm("Wollen Sie den User <i>" + theuser
							+ "</i> wirklich l&ouml;schen?",
							"User l\u00f6schen"))
						return;
					String contacts = KFileManager.readFile(User.getHome()
							+ "/KemaChat/contactlist");
					String exit = "";
					StringTokenizer st = new StringTokenizer(contacts, "\n");
					while (st.hasMoreTokens()) {
						String next = st.nextToken();
						if (!next.equals(theuser)) {
							exit += next + "\n";
						}
					}
					KFileManager.writeFile(User.getHome()
							+ "/KemaChat/contactlist", exit);
					loadUserData();
					repaintList(true);
				}
			});
			popup.add(chat_user);
			popup.add(delete_user);
			popup.add(add_user);
			new Thread(new Runnable() {
				public void run() {
					try {
						while (true) {
							if (popup.isShowing()) {
								for (int i = 0; i < MainUser.userlist.length; i++) {
									userwriter[i].setCursor(new Cursor(
											Cursor.DEFAULT_CURSOR));
								}
								userwriter[i2].setCursor(new Cursor(
										Cursor.DEFAULT_CURSOR));
							} else {
								for (int i = 0; i < MainUser.userlist.length; i++) {
									userwriter[i].setCursor(new Cursor(
											Cursor.HAND_CURSOR));
								}
								userwriter[i2].setCursor(new Cursor(
										Cursor.HAND_CURSOR));
							}
							Thread.sleep(100);
						}
					} catch (Exception E) {

					}
				}
			}).start();

			userwriter[i].addMouseListener(new MouseAdapter() {
				public void mouseReleased(MouseEvent arg0) {
					ChatUser nextuser = nextuser_b;
					if (arg0.isPopupTrigger()) {
						popup.show(userwriter[i2], arg0.getX(), arg0.getY());
					} else {
						if (!popup.isShowing()) {
							chat(nextuser);
						}
					}
				}

				public void mousePressed(MouseEvent me) {

					if (me.isPopupTrigger()) {
						popup.show(userwriter[i2], me.getX(), me.getY());
					}
				}

				public void mouseEntered(MouseEvent arg0) {
					ChatUser nextuser = nextuser_b;
					final String s_nextuser = KemaChat.formatText(nextuser
							.getNickName(), nextuser);
					String additional = "";
					File notexisting = new File("images/warn.png");
					File nochat = new File("images/nochat.png");
					File nolist = new File("images/notinlist.png");
					File hislist = new File(nextuser.getPath()
							+ "/KemaChat/contactlist");
					String hiscontactlist = KFileManager.readFile(hislist
							.toString());
					if (!nextuser.exists()) {
						additional += "<img src=\"file://"
								+ notexisting.getAbsolutePath()
								+ "\" height=12 width=12>";
					} else if (!hislist.exists()) {
						additional += "<img src=\"file://"
								+ nochat.getAbsolutePath()
								+ "\" height=12 width=12>";
					} else if (hiscontactlist.toLowerCase().indexOf(
							User.getName().toLowerCase() + "\n") == -1) {
						additional += "<img src=\"file://"
								+ nolist.getAbsolutePath()
								+ "\" height=12 width=12>";
					}
					if (!nextoffline[i2]) {
						userwriter[i2].setText("<html>&nbsp;&nbsp;&nbsp;&nbsp;"
								+ additional + "<b><u><font color=blue>"
								+ s_nextuser + "</font></u></b></html>");
					} else {
						userwriter[i2].setText("<html>&nbsp;&nbsp;&nbsp;&nbsp;"
								+ additional + "<b><font color=gray><u>"
								+ s_nextuser
								+ " (Offline)</u></font></b></html>");
					}
					isover[i2] = true;
				}

				public void mouseExited(MouseEvent arg0) {
					ChatUser nextuser = nextuser_b;
					final String s_nextuser = KemaChat.formatText(nextuser
							.getNickName(), nextuser);
					String additional = "";
					File notexisting = new File("images/warn.png");
					File nochat = new File("images/nochat.png");
					File nolist = new File("images/notinlist.png");
					File hislist = new File(nextuser.getPath()
							+ "/KemaChat/contactlist");
					String hiscontactlist = KFileManager.readFile(hislist
							.toString());
					if (!nextuser.exists()) {
						additional += "<img src=\"file://"
								+ notexisting.getAbsolutePath()
								+ "\" height=12 width=12>";
					} else if (!hislist.exists()) {
						additional += "<img src=\"file://"
								+ nochat.getAbsolutePath()
								+ "\" height=12 width=12>";
					} else if (hiscontactlist.toLowerCase().indexOf(
							User.getName().toLowerCase() + "\n") == -1) {
						additional += "<img src=\"file://"
								+ nolist.getAbsolutePath()
								+ "\" height=12 width=12>";
					}
					if (!nextoffline[i2]) {
						userwriter[i2].setText("<html>&nbsp;&nbsp;&nbsp;&nbsp;"
								+ additional + "<b>" + s_nextuser
								+ "</b></html>");
					} else {
						userwriter[i2].setText("<html>&nbsp;&nbsp;&nbsp;&nbsp;"
								+ additional + "<b><font color=gray>"
								+ s_nextuser + " (Offline)</font></b></html>");
					}
					isover[i2] = false;
				}
			});
		}
		main_frame.setVisible(true);
	}

	public static void error(String e) {
		DialogMessage.error("<html><b><font color=red>" + e
				+ "</font></b></html>", "Fehler");
	}

	public static void addWindowCloseButtonEvent(JButton b, JFrame f) {
		final JFrame ff = f;
		b.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ae) {
				ff.setVisible(false);
			}
		});
	}

	public static void addWindowCloseButtonEvent(MenuItem b, JFrame f) {
		final JFrame ff = f;
		b.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ae) {
				ff.setVisible(false);
			}
		});
	}

	public static void loadContactList() {
		String mainlist = KFileManager.readFile(contactlist_location);
		StringTokenizer st1 = new StringTokenizer(mainlist, "\n");
		int contactlist_length = st1.countTokens();
		// <-- Redefine the contactlist array with the new length -->
		MainUser.userlist = new String[contactlist_length];
		int counter = 0;
		while (st1.hasMoreTokens()) {
			MainUser.userlist[counter] = st1.nextToken();
			counter++;
		}
		sortContactList();
	}

	public static String formatText(String s) {
		s = s.replaceAll("%_appversion", app.version);
		s = s.replaceAll("%_username", User.getName());
		s = s.replaceAll("%_nickname", MainUser.nickname);
		s = s.replaceAll("%_appdate", app.release_date);
		s = s.replaceAll("%_userdir", MainUser.userdir);
		s = s.replaceAll("%_standarduserdir", MainUser.standard_userdir);
		s = s.replaceAll("%_design", design);
		return s;
	}

	public static String formatText(String s, ChatUser u) {
		s = s.replaceAll("%_myappversion", app.version);
		s = s.replaceAll("%_myusername", User.getName());
		s = s.replaceAll("%_mynickname", MainUser.nickname);
		s = s.replaceAll("%_myuserdir", MainUser.userdir);
		s = s.replaceAll("%_standarduserdir", MainUser.standard_userdir);
		s = s.replaceAll("%_mydesign", design);

		s = s.replaceAll("%_appversion", u.getKemaChatVersion());
		s = s.replaceAll("%_username", u.getName());
		s = s.replaceAll("%_nickname", u.getNickName());
		s = s.replaceAll("%_design", u.getDesign());

		return s;
	}

	public static void sortContactList() {
		int count_online = 0;
		int count_offline = 0;
		for (int i = 0; i < MainUser.userlist.length; i++) {
			// <-- Define the length for the useronline array -->
			ChatUser nextuser = new ChatUser(MainUser.userlist[i]);
			if (nextuser.isOnline()) {
				count_online++;
				// p("NEXT USER IS ONLINE "+nextuser.getName());
			} else {
				// p("NEXT USER IS OFFLINE "+nextuser.getName());
				count_offline++;
			}
		}
		// <-- Redefine the useronline array with the new length -->
		users_online = new String[count_online];
		users_offline = new String[count_offline];
		for (int i = 0; i < users_online.length; i++) {
			// <-- Fill the useronline array -->
			ChatUser nextuser = new ChatUser(MainUser.userlist[i]);
			if (nextuser.isOnline()) {
				users_online[i] = nextuser.getName();
			}

		}
		for (int i = 0; i < users_offline.length; i++) {
			// <-- Fill the useroffline array -->
			ChatUser nextuser = new ChatUser(MainUser.userlist[i]);
			if (!nextuser.isOnline()) {
				users_offline[i] = nextuser.getName();
			}
		}
	}

	public static void createContactList() {
		KFileManager.writeFile(contactlist_location, "");
	}

	public static void loadUserData() {
		setProgressValue(5, "Lade Userinformationen...");
		File userdata = new File(User.getHome() + "/Library/KemaChat");
		if (!userdata.exists()) {
			userdata.mkdirs();
		}
		userdata = new File(User.getHome() + "/KemaChat");
		if (!userdata.exists()) {
			userdata.mkdirs();
		}
		setProgressValue(6, "Lade Userinformationen...");
		userdata = new File(userdata_location);
		if (!userdata.exists()) {
			createUserData();
		}
		setProgressValue(7, "Lade Userinformationen...");
		userdata = new File(log_location);
		if (userdata.exists()) {
			userdata.mkdirs();
		}
		userdata = new File(contactlist_location);
		if (!userdata.exists()) {
			createContactList();
		}
		setProgressValue(8, "Lade Userinformationen...");
		loadContactList();
		setProgressValue(9, "Lade Userinformationen...");
		String read = KFileManager.readFile(userdata_location);
		StringTokenizer st1 = new StringTokenizer(read, "\n");
		/*
		 * 0 --> nickname 1 --> mainframe_dimension 2 --> mainframe_location 3
		 * --> userdir 4 --> chatframe_dimension 5 --> chatframe_location 6 -->
		 * write_color1 write_color2 write_color3 7 --> write_font 8 -->
		 * normal/bold 9 --> normal/italic 10 --> normal/underline 11 --> allow
		 * unknown users to talk with 12 --> avatar size
		 * 
		 */
		setProgressValue(10, "Lade Userinformationen...");
		try {
			if (!st1.hasMoreTokens())
				return;
			MainUser.nickname = st1.nextToken();
			if (!st1.hasMoreTokens())
				return;
			MainUser.mainframe_dimension = toDimension(st1.nextToken());
			if (!st1.hasMoreTokens())
				return;
			MainUser.mainframe_location = toPoint(st1.nextToken());
			if (!st1.hasMoreTokens())
				return;
			MainUser.userdir = st1.nextToken();
			if (!st1.hasMoreTokens())
				return;
			MainUser.chatframe_dimension = toDimension(st1.nextToken());
			if (!st1.hasMoreTokens())
				return;
			MainUser.chatframe_location = toPoint(st1.nextToken());
			if (!st1.hasMoreTokens())
				return;
			String forcolor[] = st1.nextToken().split(" ");
			MainUser.write_color1 = Integer.parseInt(forcolor[0]);
			MainUser.write_color2 = Integer.parseInt(forcolor[1]);
			MainUser.write_color3 = Integer.parseInt(forcolor[2]);
			if (!st1.hasMoreTokens())
				return;
			MainUser.write_font = st1.nextToken();
			if (!st1.hasMoreTokens())
				return;
			MainUser.write_bold = Integer.parseInt(st1.nextToken());
			if (!st1.hasMoreTokens())
				return;
			MainUser.write_italic = Integer.parseInt(st1.nextToken());
			if (!st1.hasMoreTokens())
				return;
			MainUser.write_underline = Integer.parseInt(st1.nextToken());
			if (!st1.hasMoreTokens())
				return;
			MainUser.allow = Integer.parseInt(st1.nextToken());
			if (!st1.hasMoreTokens())
				return;
			MainUser.avatar_size = Integer.parseInt(st1.nextToken());
			if (!st1.hasMoreTokens())
				return;
			MainUser.save_history = st1.nextToken().equals("true") ? true
					: false;
			if (!st1.hasMoreTokens())
				return;
			MainUser.ad_color = Integer.parseInt(st1.nextToken());
			if (!st1.hasMoreTokens())
				return;
			MainUser.background_constant = st1.nextToken();
			if (!st1.hasMoreTokens())
				return;
			MainUser.sound_login = st1.nextToken();
			if (!st1.hasMoreTokens())
				return;
			MainUser.sound_newmessage = st1.nextToken();
			if (!st1.hasMoreTokens())
				return;
			MainUser.sound_logout = st1.nextToken();
			if (!st1.hasMoreTokens())
				return;
			MainUser.sound_always_newmessage = st1.nextToken().equals("true") ? true
					: false;
			if (!st1.hasMoreTokens())
				return;
			MainUser.sound_play_login = st1.nextToken().equals("true") ? true
					: false;
			if (!st1.hasMoreTokens())
				return;
			MainUser.sound_play_newmessage = st1.nextToken().equals("true") ? true
					: false;
			if (!st1.hasMoreTokens())
				return;
			MainUser.sound_play_logout = st1.nextToken().equals("true") ? true
					: false;
			if (!st1.hasMoreTokens())
				return;
			MainUser.allow_self = st1.nextToken().equals("true") ? true : false;
			if (!st1.hasMoreTokens())
				return;
			MainUser.background = st1.nextToken();
			if (!st1.hasMoreTokens())
				return;
		} catch (Exception E) {
			E.printStackTrace();
			DialogMessage
					.error("Die Usereinstellungsdatei ist besch&auml;digt!!<br><br>KemaChat wird trotzdem gestartet (force).");
		}
	}

	public void inputUserData() {
		MainUser.mainframe_dimension = main_frame.getSize();
		MainUser.mainframe_location = main_frame.getLocation();
	}

	public static void createUserData() {
		String toWrite = "" + MainUser.nickname + "\n"
				+ (int) MainUser.mainframe_dimension.width + " "
				+ (int) MainUser.mainframe_dimension.height + "\n"
				+ (int) MainUser.mainframe_location.getX() + " "
				+ (int) MainUser.mainframe_location.getY() + "\n"
				+ MainUser.userdir + "\n"
				+ (int) MainUser.chatframe_dimension.width + " "
				+ (int) MainUser.chatframe_dimension.height + "\n"
				+ (int) MainUser.chatframe_location.getX() + " "
				+ (int) MainUser.chatframe_location.getY() + "\n"
				+ MainUser.write_color1 + " " + MainUser.write_color2 + " "
				+ MainUser.write_color3 + "\n" + MainUser.write_font + "\n"
				+ MainUser.write_bold + "\n" + MainUser.write_italic + "\n"
				+ MainUser.write_underline + "\n" + MainUser.allow + "\n"
				+ MainUser.avatar_size + "\n" + MainUser.save_history + "\n"
				+ MainUser.ad_color + "\n" + MainUser.background_constant + "\n" 
				+ MainUser.sound_login + "\n" + MainUser.sound_newmessage + "\n"
				+ MainUser.sound_logout + "\n" + MainUser.sound_always_newmessage + "\n"
				+ MainUser.sound_play_login + "\n" + MainUser.sound_play_newmessage + "\n"
				+ MainUser.sound_play_logout + "\n" + MainUser.allow_self +"\n"
				+ MainUser.background+"\n";
		KFileManager.writeFile(userdata_location, toWrite);
		KFileManager.writeFile(User.getHome() + "/KemaChat/nickname/",
				MainUser.nickname);
	}

	public void preferences(int index) {
		KPreferencesPane.main.setVisible(true);
	}

	public static Dimension toDimension(String x) {
		StringTokenizer st = new StringTokenizer(x, " ");
		return new Dimension(Integer.parseInt(st.nextToken()), Integer
				.parseInt(st.nextToken()));
	}

	public static Point toPoint(String x) {
		StringTokenizer st = new StringTokenizer(x, " ");
		return new Point(Integer.parseInt(st.nextToken()), Integer.parseInt(st
				.nextToken()));
	}

}