package kemachat;

import java.io.*;

import kwt.*;

/**
 * 
 *
 * @author Matteo Pagamici
 * Copyright (c) 2006 Matteo Pagamici
 * All rights reserved
 *
 */

public class ChatUser {
	public String nickname = "";

	public String path = "";

	public String name = "";
	
	public String version = "";
	
	public String design = "";
	

	public ChatUser(String Name) {
		name = Name;
		path = searchUser(Name);
		File nickname_file = new File(path + "/KemaChat/nickname");
		File version_file = new File(path + "/KemaChat/version");
		File design_file = new File(path + "/KemaChat/design");
		if (nickname_file.exists()) {
			nickname = KUserFileManager.readFile(path + "/KemaChat/nickname");
		} else {
			nickname = name;
		}
		if (version_file.exists()) {
			version = KUserFileManager.readFile(path + "/KemaChat/version");
		} else {
			version = "Unknown";
		}
		if(version.endsWith("\n")) {
			version = version.substring(0, version.length()-1);
		}
		if(design_file.exists()) {
			design = KFileManager.readFile(path+"/KemaChat/design");
		} else {
			design = "Brush Metal";
		}
	}

	public void refresh() {
		path = searchUser(name);
		File nickname_file = new File(path + "/KemaChat/nickname");
		File design_file = new File(path + "/KemaChat/design");
		if (nickname_file.exists()) {
			nickname = KUserFileManager.readFile(path + "/KemaChat/nickname");
		} else {
			nickname = name;
		}
		if(design_file.exists()) {
			design = KFileManager.readFile(path+"/KemaChat/design");
		} else {
			design = "Brush Metal";
		}
		nickname = nickname.replaceAll("\n", "");
	}

	public boolean isOnline() {
		File user_online = new File(path + "/KemaChat/online");
		// System.out.println("HIS PATH IS "+path+"/KemaChat/online -- exists:
		// "+user_online.exists());
		return user_online.exists();
	}

	public boolean exists() {
		File path_file = new File(path);
		return path_file.exists();
	}
	public String getKemaChatVersion() {
	
		return version;
	}
	public boolean amInHisContactList() {
		String his_contactlist = KUserFileManager.readFile(path
				+ "/KemaChat/contactlist");
		if (his_contactlist.toLowerCase().indexOf(User.getName().toLowerCase()) == -1) {
			return false;
		} else {
			return true;
		}
	}

	public String getName() {
		refresh();
		return name;
	}

	public String getNickName() {
		refresh();
		return nickname;
	}

	public String getPath() {
		refresh();
		return path;
	}
	public String getDesign() {
		refresh();
		return design;
	}
	private static void p(String p) {
		System.out.println("KEMACHAT DEBUG MODE - "+p);
	}
	public static String searchUser(String username) {
		for (int i = 2; i < 20; i++) {
			File tr1 = new File(MainUser.userdir + "/200" + i + "/" + username);
			if (i > 9) {
				tr1 = new File(MainUser.userdir + "/20" + i + "/" + username);
			}
			if (tr1.exists() && tr1.isDirectory()) {
				if(i > 9) 
					return MainUser.userdir + "/20" + i + "/" + username;
				else
					return MainUser.userdir + "/200" + i + "/" + username;
			}
		}
		File lehrer_file = new File("/private/Network/Servers/filel.hopro.edu/Volumes/User/User/"+username);
		if(lehrer_file.exists() && lehrer_file.isDirectory()) {
			p("IsTeacher.");
			return lehrer_file.toString();
		}
		return MainUser.userdir + "" + username;
	}

	public static String[] getCompleteUserList() {
		if (MainUser.allow == 1) {
			String exit[] = new String[200];
			int count = 0;
			for (int i = 2; i < 20; i++) {
				// <-- count -->
				File tr1 = new File(MainUser.userdir + "/200" + i + "/");
				if (i > 9) {
					tr1 = new File(MainUser.userdir + "/20" + i + "/");
				}
				if (tr1.exists()) {
					File next[] = tr1.listFiles();
					int count2 = 0;
					for (int z = 0; z < next.length; z++) {
						File nextfile = next[z];
						if (!nextfile.toString().startsWith(".")
								&& nextfile.isDirectory()) {
							count2++;
						}
					}
					count += count2;
				}
			}
			File tr = new File(MainUser.userdir);
			File next_[] = tr.listFiles();
			int count2 = 0;
			for (int z = 0; z < next_.length; z++) {
				File nextfile = next_[z];
				if (!nextfile.toString().startsWith(".")
						&& nextfile.isDirectory()) {
					count2++;
				}
			}
			count += count2;
			exit = new String[count];
			int counter = 0;
			for (int i = 2; i < 20; i++) {
				// <-- count -->
				File tr1 = new File(MainUser.userdir + "/200" + i + "/");
				if (i > 9) {
					tr1 = new File(MainUser.userdir + "/20" + i + "/");
				}
				if (tr1.exists()) {
					File next[] = tr1.listFiles();
					for (int z = 0; z < next.length; z++) {
						File nextfile = next[z];
						if (!nextfile.toString().startsWith(".")
								&& nextfile.isDirectory()) {
							exit[counter] = nextfile.toString();
							exit[counter] = exit[counter].substring(
									exit[counter].lastIndexOf("/") + 1,
									exit[counter].length());
							counter++;
						}
					}
				}
			}
			File trb = new File(MainUser.userdir);
			File next_b[] = trb.listFiles();
			for (int z = 0; z < next_b.length; z++) {
				File nextfile = next_b[z];
				if (!nextfile.toString().startsWith(".")
						&& nextfile.isDirectory()) {
					exit[counter] = nextfile.toString();
					exit[counter] = exit[counter].substring(exit[counter]
							.lastIndexOf("/") + 1, exit[counter].length());
					counter++;
				}
			}
			return exit;
		} else {
			return MainUser.userlist;
		}

	}
}