package kwt;

import java.io.File;
import java.io.IOException;

import javax.sound.sampled.AudioInputStream;
import javax.sound.sampled.AudioSystem;
import javax.sound.sampled.Clip;
import javax.sound.sampled.DataLine;
import javax.sound.sampled.LineUnavailableException;
import javax.sound.sampled.UnsupportedAudioFileException;

public class Sound {
	public void play() {
		if (clip == null) {
			
			return;
		}

		// clip.loop(Clip.LOOP_CONTINUOUSLY);
		clip.start();
	}

	public void loop() {
		clip.loop(Clip.LOOP_CONTINUOUSLY);
	}

	public Sound(String filename) {
		newSound(filename);
	}

	public void stop() {
		if (clip != null)
			clip.loop(0);
	}

	public void newSound(String filename) {
		File soundFile = new File(filename); // File object for filename

		try {
			AudioInputStream source = AudioSystem
					.getAudioInputStream(soundFile);
			DataLine.Info clipInfo = new DataLine.Info(Clip.class, source
					.getFormat());
			if (AudioSystem.isLineSupported(clipInfo)) {
				// Create a local clip to avoid discarding the old clip
				Clip newClip = (Clip) AudioSystem.getLine(clipInfo); // Create
																		// the
																		// clip
				newClip.open(source);

				// Deal with previous clip
				if (clip != null) {
					if (clip.isActive()) // If it's active
					{
						clip.stop(); // ...stop it
						// ..and reset the button label
					}
					if (clip.isOpen()) // If it's open...
						clip.close(); // ...close it.
				}
				clip = newClip; // We have a clip, so discard old
				// Save the filename
			} else {
				

			}
		} catch (UnsupportedAudioFileException e) {
			//e.printStackTrace();
		} catch (LineUnavailableException e) {
			//e.printStackTrace();
		} catch (IOException e) {
			//e.printStackTrace();
		}
	}

	private Clip clip;
}
