package kwt;

import java.io.*;

import com.apple.eio.*;
import java.net.*;
import java.util.*;
import java.awt.*;
import javax.swing.*;

/**
 * 
 * 
 * @author Matteo Pagamici Copyright (c) 2006 Matteo Pagamici All rights
 *         reserved
 * 
 */

public class Updater {

	public String version = "";

	public String features = "";

	public String filename = "";

	public String url = "";

	public boolean canUpdate = false;

	public String title = "";

	public String name = "";

	public Window w = new Window(new JFrame(""));

	public JLabel info = new JLabel("<html><br><b>Updating...</b></html>");

	public JProgressBar status = new JProgressBar();

	public Updater(String Title, String Name) {
		title = Title;
		name = Name;
		try {
			String exit = readUrl("http://www.rossoforte.ch/kema/kema/updater/updater.php?app="
					+ name);
			StringTokenizer st = new StringTokenizer(exit, "\n");
			version = st.nextToken();
			url = st.nextToken();
			while (st.hasMoreTokens()) {
				features += st.nextToken() + "\n";
			}
			canUpdate = true;
		} catch (NoSuchElementException nsee) {
			System.err
					.println("Kema AutoUpdater - Not enough tokens in the read string.");
			return;
		} catch (Exception E) {
			System.err
					.println("Kema AutoUpdater - No internet connection was found.");
		}
	}

	public boolean openUpdatePage() {
		try {
			FileManager.openURL("http://www.rossoforte.ch/kema/kema/" + name
					+ ".php");
		} catch (Exception E) {

		}
		return true;
	}

	public boolean update() {
		if (canUpdate) {
			w.setSize(500, 100);
			w.setLocation(400, 300);
			w.add(info, BorderLayout.NORTH);
			w.add(status);
			status.setStringPainted(true);
			info.setText("<html><br><b>" + title
					+ ": Reading Update...</b></html>");
			try {
				int length = 0;
				// GET THE LENGTH
				char CBuf2[] = new char[1024];
				URL Url = new URL(url);
				InputStreamReader inp = new InputStreamReader(Url.openStream());
				int cnt2 = 1;
				while (cnt2 > 0) {
					cnt2 = inp.read(CBuf2, 0, 1024);
					if (cnt2 < 0) {
						break;
					}
					length++;
				}
				status.setMaximum(length + 20);
				status.setMinimum(0);
				inp.close();
				w.setVisible(true);
				info.setText("Preparing update...");
				status.setValue(0);
				// WRITE
				char CBuf[] = new char[1024];
				Url = new URL(url);
				status.setValue(3);
				inp = new InputStreamReader(Url.openStream());
				filename = url
						.substring(url.lastIndexOf("/") + 1, url.length());
				FileWriter fw = new FileWriter(filename);
				status.setValue(8);
				int cnt = 1;
				int counter = 0;
				status.setValue(10);
				info.setText("Updating...");
				while (cnt > 0) {
					cnt = inp.read(CBuf, 0, 1024);
					if (cnt < 0) {
						break;
					}
					counter++;
					fw.write(CBuf, 0, cnt);
					status.setValue(cnt + counter);
				}
				info.setText("Completing...");
				status.setValue(status.getMaximum() - 1);
				fw.close();
				inp.close();
				status.setValue(status.getMaximum());
				System.out.println("KEMA WEBEDITOR - Update to version "
						+ version + " completed.");
			} catch (Exception E) {
				System.err
						.println("KEMA WEBEDITOR - Error while updating to version "
								+ version + ".");
				info
						.setText("<html><br><b>Error while updating. Please quit this application.</b></html>");
				return false;
			}
			w.setVisible(false);
			return true;
		} else {
			return false;
		}
	}

	public static String readUrl(String Url) throws IOException {
		URL theurl = new URL(Url);
		URLConnection connection = theurl.openConnection();
		BufferedReader br = new BufferedReader(new InputStreamReader(connection
				.getInputStream()));
		String next;
		String exit = "";
		while ((next = br.readLine()) != null) {
			exit += next + "\n";
		}
		br.close();
		return exit;
	}

	public void write(String uRl, String name) {
		try {
			char CBuf[] = new char[1024];
			URL Url = new URL(uRl);
			InputStreamReader inp = new InputStreamReader(Url.openStream());
			FileWriter fw = new FileWriter(name);
			int cnt = 1;
			while (cnt > 0) {
				cnt = inp.read(CBuf, 0, 1024);
				if (cnt < 0) {
					break;
				}
				fw.write(CBuf, 0, cnt);
			}
			fw.close();
			inp.close();
		} catch (Exception E) {

		}
	}
}
